/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Stylechooser $Revision: 1.26.2.3 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Stylechooser");
dojo.require("epages.widget.LocalizedWidget");
dojo.require("epages.data.ItemFileReadStore");
dojo.require('epages.cartridges.de_epages.design.widget.StyleList');
dojo.require("epages.cartridges.de_epages.design.widget.Stylelistitem");
dojo.require("epages.cartridges.de_epages.design.widget.Stylelistitemcolor");
dojo.require("epages.widget.Slides");
dojo.require('dijit.layout.AccordionContainer');
dojo.require('epages.cartridges.de_epages.design.widget.Stylegrouptree');
dojo.require("epages.html");
dojo.require("epages.event");
dojo.require("epages.template");
dojo.require('epages.io.json');


dojo.declare(
	"epages.cartridges.de_epages.design.widget.Stylechooser",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		styleTemplateId     : '',
		selectedStyleGroupID: '',   // initial and current StyleGroupID
		styleGroupStore     : undefined,
		styleGroupData      : undefined,
		styleGroupDataVar   : '',
		actionStyleGroupMaps: 'JSONGetStyleGroupMaps',
		objectId            : '',
		url                 : '?',
		customizeLevelImage : '',
		customizeLevel      : '',
		styleName           : '&nbsp;', // empty name needed
		systemStyleDir      : '',
		'class'             : '',
		jsId                : '',

		/**
		 * private properties
		 */
		_styleGroupMapData     : undefined,
		_lastSelStyleGroupNode : undefined,

		/**
		 * widget properties
		 */

		/* widgets in Template */
		widgetsInTemplate: true,

		/* templates / translation */
		loopTemplatePath       : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/Stylechooser.html'),
		loopTemplateString     : '',
		loopitemTemplatePath   : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/Stylechooser-loopitem.html'),
		loopitemTempalteString : '',
		translationName        : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/translation'),

		// override
		postMixInProperties: function() {
			this.inherited('postMixInProperties', arguments);
			// initialize values

			// prepare data for data store
			if(this.styleGroupDataVar !== ""){
				this.styleGroupData = eval(this.styleGroupDataVar);
			}else{
				console.warn("'styleGroupDataVar ' not found in "+this.declaredClass);
			}
			if(!epages.vars.StyleTemplates){
				console.warn("'epages.vars.StyleTemplates' not found in "+this.declaredClass);
			}

			// init mapping var for caching
			this._styleGroupMapData = $H();

			// load templates
			this.loopTemplateString=this._loadTemplate(this.loopTemplatePath);
			this.loopitemTemplateString=this._loadTemplate(this.loopitemTemplatePath);

			// top style groups
			var sg=this.styleGroupData.items;

			if(sg){
				// generate this.templateString
				var loopHtml="";

				// build loop items
				for(var el in sg) {
					if(sg[el].isRoot) {
						var tmpl = $TMPL (this.loopitemTemplateString, sg[el] , false);
						loopHtml+=tmpl.generateOutput();
					}
				}
				// insert items into wrapper
				var tmpl2 = $TMPL (this.loopTemplateString, {
					'LoopAccordionPanes': loopHtml
					}, false);
				this.templateString=tmpl2.generateOutput();

				// set customizeLevelImage
				this.customizeLevelImage=epages.vars.StoreRoot+'/BO/icons/content_img_customizelevel'+this.customizeLevel+'.png';
			} else {
				console.warn("epages.vars.StyleGroups not defined in widget Stylechooser");
			}
		},

		postCreate: function() {
			this.inherited('postCreate', arguments);

			this.setCustomizeLevel(this.customizeLevel);
			dojo.addClass(this.domNode, this['class']);

			// events / topics
			dojo.subscribe(this.id + '_stylegroup/select',             this, 'onStyleGroupSelect');
			dojo.subscribe(this.id + '_styletemplatecolorlist/select', this, 'onStyleTemplateSelect');
			dojo.subscribe(this.id + '_styletemplatelist/select',      this, function() {
				this.onStyleTemplateSelect.apply(this, arguments);
				// select ColorTemplate
				var templateColorList = this.styleTemplateColorListWidget;
				var templateColorListItem = templateColorList.getItemByIdentity('styleTemplateId', this.styleTemplateId);
				if(templateColorListItem){ 
					templateColorList.select(templateColorListItem);
				}
			});

		},

		startup: function() {
			this.inherited('startup', arguments);
			// set data store reference
			this.styleGroupStore= eval(this.jsId+'styleGroupStore');
			if(this.styleGroupStore) {
				// copy original templateid before it is changed
				var styleTemplateId = this.styleTemplateId;
				// open tree node
				var treeNode = this.expandTreeByIdentity(this.selectedStyleGroupID);
				// show styles of selected stylegroup
				var storeItem = this.styleGroupStore.getItemByIdentity(this.selectedStyleGroupID);
				if(storeItem) {
					this.onStyleGroupSelect(storeItem, treeNode);
				}

				// select Style
				if (styleTemplateId) {
					var styleList = this.styleTemplateListWidget;
					var styleListItem = styleList.getItemByIdentity('styleTemplateId', styleTemplateId);
					if(styleListItem) {
						styleList.select(styleListItem);  // select item in list and display
					} else {
						// not found, try to find it in all templates
						this.displayAllStyles();
						styleListItem = styleList.getItemByIdentity('styleTemplateId', styleTemplateId);
						if(styleListItem) {
							styleList.select(styleListItem);  // select item in list and display
						} else {
							this.displayCurrentStyle(); // display style anyway
						}
					}
				} else {
					this.displayCurrentStyle(); // display style anyway
				}

				// select ColorTemplate
				var templateColorList = this.styleTemplateColorListWidget;
				var templateColorListItem = templateColorList.getItemByIdentity('styleTemplateId', styleTemplateId);
				if(templateColorListItem) {
					templateColorList.select(templateColorListItem);
				}

				// fix layout
				this.fixLayout();
			} else {
				console.warn('StyleGroupStore (jsId="'+this.jsId+'styleGroupStore") not found in '+this.declaredClass);
			}
		},

		expandTreeByIdentity: function(identity) {
			var sg = this.styleGroupData.items;
			for(var el in sg) {
				if(sg[el].isRoot) {
					var accordionPane= $$('AccordionPane_'+sg[el].alias);
					this.accordionContainerWidget.selectChild(accordionPane);
					if (sg[el].objectId == identity) {

					} else {
						var tree = $$('Tree_'+sg[el].alias);
						tree.selectedId = identity;
						this.connect(tree,"onLoad", "onTreeOnLoad");
					}
				}
			}
			return undefined;
		},
		onTreeOnLoad: function(treeNode){
			if(treeNode){
				this.highlightStyleGroup(treeNode);
			}
		},

		fixLayout: function() { // fixes display problems in firefox
			var _this = this;
			window.setTimeout(function() {_this.accordionContainerWidget.resize();      }, 200);
		},

		_loadTemplate : function(url) {
			var tmplString="";
			dojo.xhrGet({
				url:  url,
				sync: true,
				load: function(data){
					tmplString=data;
				},
				mimetype: "text/plain"
			});
			return tmplString;
		},

		_load: function (styleGroupId) {
			if (styleGroupId == '' || styleGroupId === undefined){
				console.warn("Can't load undefined stylegroupid in "+this.declaredClass);
			}else {
				if (this._styleGroupMapData.existsKey(styleGroupId)){
					return this._styleGroupMapData.get(styleGroupId);
				}
				var json = new epages.io.Json();
				var childrenData = json.loadSync(this.url, {
					'ViewAction'  : this.actionStyleGroupMaps,
					'ObjectID'    : this.objectId,
					'StyleGroupID': styleGroupId
				});

				this._styleGroupMapData.set(styleGroupId, childrenData);
				return childrenData;
			}
		},

		onStyleGroupSelect: function(/* FileReaderStoreItem */item, /* TreeNode */ node) {
			var response = this._load(item.objectId);
			if(response.data) {
				this.styleTemplateListWidget.setChildren(response.data);
				this.styleTemplateListWidget.select(this.styleTemplateListWidget.children[0]);
				// set input values
				this.styleGroupInputNode.value = item.objectId;
				this.selectedStyleGroupID=item.objectId;
				if (node) {
					this.highlightStyleGroup(node);
				}
				this.switchClassAvailableStyles();
			} else{
				console.warn("Response doesn't contain data in "+this.declaredClass);
			}
		},

		highlightStyleGroup: function(newNode) {
			if(this._lastSelStyleGroupNode !== undefined && this._lastSelStyleGroupNode.labelNode !== undefined && this._lastSelStyleGroupNode !== newNode) {
				dojo.removeClass(this._lastSelStyleGroupNode.labelNode, "Selected");
			}
			this._lastSelStyleGroupNode = newNode;
		if(newNode !== undefined && newNode.labelNode !== undefined) {
				dojo.addClass(this._lastSelStyleGroupNode.labelNode, "Selected");
			}
		},

		onStyleTemplateSelect: function(/* ElementListItem */item) {
			// set template values
			this.styleTemplateInputNode.value = item.data.styleTemplateId;
			this.systemStyleDirInputNode.value = item.data.styleDir;
			this.styleNameInputNode.value = item.data.title;

			// set widget attribute
			this.styleTemplateId = item.data.styleTemplateId;

			// show preview
			this.displayCurrentStyle({
				customizeLevel: item.data.customizeLevel,
				variations:     item.data.variations,
				listClassName:  item.listClassName
			});
			dojo.publish(this.id+'/selecttemplate', [item]);
		},

		displayCurrentStyle: function(opt) {
			if(opt === undefined){
				var opt = {};
			}
			if(this.systemStyleDirInputNode.value != "" ){
				$$("stylePreview").addImage({fit:true,image:this.systemStyleDirInputNode.value + '/img_medium_stylepreview.gif'}, 1);
			}
			if(this.styleNameInputNode.value != ""){
				this.styleNameNode.firstChild.data=this.styleNameInputNode.value;
			}
			if(opt.listClassName != "Stylelistitemcolor"){
				if (opt.variations && opt.variations.length> 1) {
					this.styleTemplateColorListWidget.setChildren(opt.variations);
					this.selectColorsNode.style.display = "";
				} else {
					this.selectColorsNode.style.display = "none";
				}
			}
			if(opt.customizeLevel) {
				this.setCustomizeLevel(opt.customizeLevel);
				this.showCustomizeLevel();
			} else{
				this.hideCustomizeLevel();
			}
		},

		setCustomizeLevel: function(/* string */level) {
			if(epages.vars.StoreRoot === undefined){
				console.warn("'epages.vars.StoreRoot' is undefined in "+this.declaredClass);
			}
			this.customizeLevelImageNode.src = epages.vars.StoreRoot+'/BO/icons/content_img_customizelevel'+level+'.png';
			this.customizeLevelInputNode.value=level;
			var clText=this.translate("CustomizeLevel"+level); // comment.translate:CustomizeLevel0,CustomizeLevel1,CustomizeLevel2,CustomizeLevel3,CustomizeLevel4,CustomizeLevel5
			this.customizeLevelTextNode.innerHTML = clText;
			this.customizeLevelImageNode.alt=clText;
			this.customizeLevelImageNode.title=clText;
		},

		hideCustomizeLevel: function() {
			this.customizeLevelNode.style.display="none";
		},

		showCustomizeLevel: function() {
			this.customizeLevelNode.style.display="";
		},


		displayAllStyles: function() {
			epages.html.replaceClass(this.displayAllNode, "HideElement" , "DoActionLink");
			epages.html.replaceClass(this.displayAvailableNode, "DoActionLink", "HideElement");
			this.styleTemplateListWidget.setChildren(epages.vars.StyleTemplates);
		},

		displayAvailableStyles: function() {
			this.switchClassAvailableStyles();
			var response = undefined;

			if(this.selectedStyleGroupID){   // select current stylegroup
				response= this._load(this.selectedStyleGroupID);
			}else {                           // if not defined select first stylegroup
				var item = this.styleGroupData.items[0];
				if(item.children[0]){
					item =item.children[0]; // first category in splitted tree
				}
				response= this._load(item.objectId);
			}
			this.styleTemplateListWidget.setChildren(response.data);
		},

		switchClassAvailableStyles: function() {
			epages.html.replaceClass(this.displayAllNode, "DoActionLink" , "HideElement");
			epages.html.replaceClass(this.displayAvailableNode, "HideElement", "DoActionLink");
		},

		getStyleTemplateId: function() {
			return this.styleTemplateId;
		}

	}
);
