/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Toolfontfamily $Revision: 1.14.2.1 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Toolfontfamily");
dojo.require("epages.widget.LocalizedWidget");
dojo.require("epages.widget.Menu");
dojo.require("epages.event");
dojo.require("dijit._Container");

dojo.declare(
	"epages.cartridges.de_epages.design.widget.Toolfontfamily",
	[epages.widget.LocalizedWidget, dijit._Contained],
	{
		/**
		 * public properties
		 */
		label               : '',
		fontFamily          : '',
		fontType            : '', /* Headline, Paragraph, Link, ... */
		objectId            : '',

		/**
		 * private properties
		 */
		templateType        : "tablerow",
		defaultTemplateTyp  : "tablerow",
		_templateMapping:{
			tablerow          : 'Toolfontfamily.html',
			xlicon            : 'Toolfontfamilyxlicon.html'
		},

		_lastSelected       : null,
		_menuWidget         : null,
		_popup              : null,
		_fonts: {
			'Arial'           : "Arial, Verdana, Helvetica",
			'Courier New'     : "Courier New, Verdana, Helvetica",
			'Georgia'         : "georgia, Times New Roman, arial, sans-serif",
			'Lucida Sans'     : "Lucida Sans Unicode, Lucida Sans, Verdana, Helvetica",
			'Tahoma'          : "Tahoma, Verdana, Helvetica",
			'Times New Roman' : "Times New Roman, Times",
			'Trebuchet MS'    : "Trebuchet MS, Verdana, Arial, Helvetica",
			'Verdana'         : "Verdana, Arial, Helvetica"
		},

		/**
		 * widget properties
		 */
		widgetType      : 'Toolfontfamily',
		templatePath    : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/Toolfontfamily.html'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/translation'),
		imagePath       : epages.themeUrl('images'),

		postMixInProperties: function(){
			this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates');
			this.inherited("postMixInProperties", arguments);
		},

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			this.fontSelectNode.value=this.fontFamily;
			if(this.clickNode) {
				this._menuWidget= new epages.widget.Menu();

				for(var i in this._fonts){
					this._addFontRow(i);
				}
				this._menuWidget.startup();
			}
		},

		_addFontRow: function(/*integer*/i) {
		// summary: add menu entry (link)
			var parentWidget=this;
			var entry= new dijit.MenuItem({
				label: i,
				iconClass: 'MinimizeIcon',
				onClick: function() {
					parentWidget.switchFont(i);
					dijit.popup.close(parentWidget._menuWidget);
				},
				id: 'font'+i
			});

			entry.containerNode.style.fontFamily= this._fonts[i];
			entry.containerNode.style.fontSize= '12px';
			this._menuWidget.addChild(entry);

			if(this.fontFamily == this._fonts[i]) {
				this._lastSelected=entry.domNode;
				dojo.addClass(this._lastSelected, "Selected" );
			}

		},

		showFontMenu:	function()	{
		// summary: show menu
		// summary: open the popup to the side of the current menu item
			dijit.popup.open({
				parent:this.domNode,
				popup:this._menuWidget,
				around: this.domNode
			});
		},

		_onBlur: function () {
			dijit.popup.close(this._menuWidget);
		},

		switchFont: function(/*ObjectIndex*/fontIndex) {
			this.fontSelectNode.value=this._fonts[fontIndex];
			epages.event.fire(this.fontSelectNode,"change");
			if(this._lastSelected) {
				dojo.removeClass(this._lastSelected, "Selected" );
			}
			this._lastSelected=$$('font'+fontIndex).domNode;
			dojo.addClass(this._lastSelected, "Selected" );
		}
	});

