/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Toolstylechooser $Revision: 1.20.2.4 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Toolstylechooser");
dojo.require("epages.widget.LocalizedWidget");
dojo.require("epages.event");
dojo.require("dijit._Container");
dojo.require("epages.widget.Modaldialog");
dojo.require("epages.cartridges.de_epages.design.widget.Stylechooser");
dojo.require('epages.widget.Message');
dojo.require("epages.io.json");

dojo.declare(
	"epages.cartridges.de_epages.design.widget.Toolstylechooser",
	[epages.widget.LocalizedWidget, dijit._Contained],
	{
		/**
		 * public properties
		 */
		label               : '',
		objectId            : '',

		// pass through attributes
		url                 : '',
		styleGroupDataVar   : '',
		styleTemplateId     : '',
		selectedStyleGroupID: '',
		shopId              : '',
		customizeLevel      : '',
		styleName           : '',
		systemStyleDir      : '',
		confirmApply        : 'true',

		/**
		 * private properties
		 */
		_dialogWidget: null,
		_styleChooserWidget: null,
		_warningDialogWidget: null,
		_selectedTemplateId : null,

		templateType        : "xlicon",
		defaultTemplateType : "xlicon",

		_templateMapping:{
			'button'            : 'ToolstylechooserButton.html',
			'xlicon'            : 'Toolstylechooserxlicon.html'
		},
		imagePath       : epages.themeUrl('images'),

		/**
		 * widget properties
		 */
		templatePath       : dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates/Toolstylechooserxlicon.html'),
		translationName    : dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates/translation'),

		postMixInProperties: function(){
			this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates');
			this.inherited("postMixInProperties", arguments);
		},

		postCreate: function() {
			this.inherited('postCreate', arguments);
			this.confirmApply = epages.string.toBoolean(this.confirmApply);
		},

		showTemplates: function() {
			if(this.templateType == "button") {
				dojo.addClass(this.clickNode, "Disabled");
			}

			if(this._styleChooserWidget==null) {
				var opt = {
						styleGroupDataVar    : this.styleGroupDataVar,
						selectedStyleGroupID : this.selectedStyleGroupID,
						styleTemplateId      : this.styleTemplateId,
						objectId             : this.objectId,
						customizeLevel       : this.customizeLevel,
						styleName            : this.styleName,
						systemStyleDir       : this.systemStyleDir,
						"class"              : "Tight"
				};
				if(this.url != ""){
					opt.url=this.url;
				}

				this._styleChooserWidget= new epages.cartridges.de_epages.design.widget.Stylechooser(opt);
			}

			if(this._dialogWidget==null) {
				var toolWidget = this;
				this._dialogWidget=new epages.widget.Modaldialog({
					options:{
						title : this.translate('SelectTemplate'),
						width : 956,
						height: 360,
						scroll: 'hidden',
						content: this._styleChooserWidget
					},
					buttons: [{
						toolWidget: toolWidget,
						label: this.translate('Apply'),
						cssClass: 'Active',
						onclick: function() {
							this._modalDialogWidget.hide();
							var selectWidget = this._contentWidget;
							toolWidget._selectedTemplateId = selectWidget.getStyleTemplateId();
							toolWidget._onApplyClick();
						}
					}, {
						label: this.translate('Cancel'),
						onclick: function() {
							this._modalDialogWidget.hide();
						}
					}]
				});
				document.body.appendChild(this._dialogWidget.domNode);
			}
			this._dialogWidget.show();
			this._styleChooserWidget.startup();
			this.templateType = "button";
			dojo.removeClass(this.clickNode, "Disabled");
		},

		_onApplyClick: function(){
			if(this.confirmApply) {
				var linkNode = $(this.id+'_DuplicateStyleLink');
				var loadingNode = $(this.id+'_DuplicateStyleLoading');
				var finishedNode = $(this.id+'_DuplicateStyleFinished');

				if(!this._warningDialogWidget){
					var messageWidget = new epages.widget.Message({
						headline:this.translation.get("LoadNewStyle"),
						message: this.translation.get("ChangeStyleWarning")
						+ '<br /><br /><a class="DialogAction Bold" id="'+this.id+'_DuplicateStyleLink" href="javascript: void(0);">'
						+ this.translation.get("CreateBackupCopyNow") + "</a>"
						+ '<span class="DialogAction Bold" id="'+this.id+'_DuplicateStyleLoading" style="display:none">'+this.translation.get("DuplicateLoading")+'...</span>'
						+ '<span class="DuplicateStyleFinished Bold" id="'+this.id+'_DuplicateStyleFinished" style="display:none">'+this.translation.get("DuplicateFinished")+'</span>',
						sizeClass:"Large",
						typeClass:"Confirmation"
					});

					var me =this;
					var buttons = [{
						label: this.translation.get("Yes"),
						cssClass: 'Active',
						onclick: function() {
							this._modalDialogWidget.hide();
							dojo.publish('uimessage/startBusy', ['ToolStylechooser', me.translate('BusyWhileSavingData')]);
							me.selectedStyleNode.value = me._selectedTemplateId;
							epages.event.fire(me.selectedStyleNode,'change');
						}
					},
					{
						label: this.translation.get("No"),
						onclick: function() {
							this._modalDialogWidget.hide();
						}
					}];

					this._warningDialogWidget = new epages.widget.Modaldialog({
						id: "Designtoolcontroller_DialogWidget",
						options:{
							title : this.translation.get("SelectTemplate"),
							width : 400,
							content: messageWidget
						},
						buttons : buttons
					});
					document.body.appendChild(this._warningDialogWidget.domNode);

					// get nodes / attach link event
					linkNode = $(this.id+'_DuplicateStyleLink');
					loadingNode = $(this.id+'_DuplicateStyleLoading');
					finishedNode = $(this.id+'_DuplicateStyleFinished');
					this.connect(linkNode, 'onclick', '_onDuplicateLinkClick');
				}
				linkNode.style.display = '';
				loadingNode.style.display = 'none';
				finishedNode.style.display = 'none';
				this._warningDialogWidget.show();
			} else { // just do it
				this.selectedStyleNode.value = this._selectedTemplateId;
				epages.event.fire(this.selectedStyleNode,'change');
			}
		},

		_onDuplicateLinkClick : function(/* event */evt) {
			var linkNode = $(this.id+'_DuplicateStyleLink');
			var loadingNode = $(this.id+'_DuplicateStyleLoading');
			var finishedNode = $(this.id+'_DuplicateStyleFinished');
			linkNode.style.display = 'none';
			loadingNode.style.display = '';

			(new epages.io.Json()).loadAsync(epages.vars.BaseUrl, function(){
				finishedNode.style.display = '';
				loadingNode.style.display = 'none';
			}, {
				ViewAction: "JSONViewResponse",
				ChangeAction: "DuplicateStyles",
				ObjectID: epages.vars.SiteID,
				ListObjectID: epages.vars.ObjectID
			});

		}
	}
);

