/*  EPages DesignToolbars JavaScript module, $Revision: 1.17.2.1 $
 *  (c) 2006 ePages GmbH
 *--------------------------------------------------------------------------
 */
dojo.provide('epages.event.displaydispatcher');
dojo.require('epages.lang.hash');
dojo.require('epages.html');

epages.event.DisplayDispatcher = function() {};

epages.event.DisplayDispatcher.prototype = {
	currentActiveID   : undefined,

	add: function(slaveID, masterClassName, doc) {
	  var doc = doc || dojo.doc;
	  var win = epages.getDocumentWindow(doc);
	  if (masterClassName == null) {
	  	// no class given => body
			var firstMaster = doc.body;
		} else {
			// find first node with given class
			var firstMaster = win.dojo.query("." + masterClassName, doc.body)[0];
		}
		if(firstMaster) {
			var me = this;
			var eventListenerCallback = function (evt) {
				dojo.stopEvent(evt);
				me.switchTo(slaveID);
			};
			if (firstMaster.addEventListener) {
				// W3C
				firstMaster.addEventListener("click", eventListenerCallback, false);
			} else {
				// IE
				firstMaster.attachEvent("onclick", eventListenerCallback);
			}
		}
	},

	switchTo: function(slaveID) {
		if(this.currentActiveID != slaveID) { // switch only if a different area is shown
			var s = $(slaveID);

			if (typeof (s.show) == 'function'){
				s.show();
			}
			else if(dojo.hasClass(s, 'NavBarInvisible')) {
				// if first child is a comment, then insert as innerHTML and parse it
				if (s.firstChild.nodeType == 8) {
					// using timeout for quicker and smoother fadein
					window.setTimeout(function() {
						s.innerHTML = s.firstChild.data;
						dojo.parser.parse(s);
						var navBarName = slaveID.replace(/^Tools(?:NavBar)?/i, '');
						dojo.publish('displaydispatcher/onCreateToolbar', [navBarName, s]);
					}, 1);
				}
			  epages.html.replaceClass(s, 'NavBarVisible', 'NavBarInvisible');
			}else{
				s.style.display = "block";
			}

			if (this.currentActiveID !== undefined) {
				var c = $(this.currentActiveID);
				if (typeof (c.hide) == 'function'){
					c.hide();
				}else if(dojo.hasClass(c, 'NavBarVisible')) {
				  epages.html.replaceClass(c, 'NavBarInvisible', 'NavBarVisible');
				}else{ 
					c.style.display = "";
				}
			}
			this.currentActiveID=slaveID;
		}
	}
};