/*
	Copyright (c) 2006-2008, epages Software GmbH
	All Rights Reserved.

	epages.format $Revision: 1.4.2.1 $

*/
dojo.provide("epages.format");
dojo.require('epages.epages');

epages.format = {

	slice: function(/*String*/value,/* integer */ length, /* boolean? */ sliceWords) {
	// summary: returns a truncated string
		if (value === undefined){
			 throw new Error("value not defined");
		}
		if (typeof value != "string"){
			throw new Error("Not a string value!");
		}
		if(!length) { 
			length = 30; 
		}
		if(!sliceWords === undefined) { 
			sliceWords= true; 
		}
		
		var valueLength = value.length;
		var absLength = length < 0 ? -length : length;
		if(valueLength < absLength){
			return value;
		}
		if (length < 0) {
				// start of new Position 70 + (- 60) + 3 = 10 + 3 = 13
				// length of new string 3 + (70 - 13) = 3 + 57 = 60
				value = value.substr((valueLength+length+3),(absLength-3));
				if(!sliceWords) {
					var firstspace = value.indexOf(" ");
					value = value.substr(firstspace,value.length);
				}
				return '...'+ value;
		}
		value = value.substr(0,length - 3);
		if(!sliceWords) {
			var lastspace = value.lastIndexOf(" ");
			value = value.substr(0,lastspace+1);
		}
		return value+'...';
	},

	scrunch: function(/*String*/ value, /* integer? */ length, /* float? */ ratio) {
		if(ratio=== undefined){
			ratio = 0.5;
		}
		if(ratio < 0 || ratio > 1){
			throw new Error("ratio value invalid only values from 0..1 allowed");
		}
		if (value === undefined){
			throw new Error("value not defined");
		}
		if (typeof value != "string"){
			throw new Error("Not a string value!");
		}
		if(!length){
			length = 30;
		}
		var absLength = length < 0 ? -length : length;
		var valueLength = value.length;
		if(valueLength <= absLength){
			return value;
		}

		var part1Length = Math.floor((length - 3) * ratio);
		var part2Length = Math.floor((length - 3) * (1 - ratio));
		var remainder = length - 3 - (part1Length + part2Length);

		var part1= value.substr(0, part1Length );
		var part2= value.substr(Math.max(0, valueLength - part2Length - remainder), valueLength);
		return part1+'...'+part2;
	}

};