/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.lang.date $Revision: 1.4.52.1 $

*/
dojo.provide('epages.lang.date');
dojo.require('epages.epages');
dojo.require('dojo.date.locale');

epages.lang.date.getWeekOfYear = function(/*Date*/dateObject, /*Number*/firstDayOfWeek, /*Number*/minDaysFirstWeek){
	if(firstDayOfWeek   === undefined){ firstDayOfWeek   = epages.vars.Locale.firstDayOfWeek;   }
	if(minDaysFirstWeek === undefined){ minDaysFirstWeek = epages.vars.Locale.minDaysFirstWeek; }

	var calc = function(date) {
		var c = new Date(date.getFullYear(), 0, 1).getDay();
		if(c==0 && firstDayOfWeek == 1){
			c = 7;
		}

		// need number 7 on monday or sunday for first full week
		var week = Math.floor((dojo.date.locale._getDayOfYear(date) + c - 1 - firstDayOfWeek) / 7);
		if (minDaysFirstWeek == 1 || minDaysFirstWeek == 7 && c == firstDayOfWeek) {
			week++;
		}
		else if (minDaysFirstWeek == 4) {
			var g = c - firstDayOfWeek;
			if (g < 4) { week++; }
		}
		return week;
	};
	var result = calc(dateObject);
	if(result < 1) { // is last week of last year
		result = calc(new Date(dateObject.getFullYear() - 1, 11,31));
	}
	if(result >= 53) { // may be first week of next year
		var newyear = calc(new Date(dateObject.getFullYear() + 1, 0, 1));
		result = newyear == 0 ? result : newyear;
	}
	return result; // Number
};
