/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.validate.css $Revision: 1.17.4.1 $

*/
dojo.provide('epages.validate.css');
dojo.require('epages.lang.hash');
dojo.require('epages.lang.array');
dojo.require('epages.lang.color');

epages.validate.css.validColors = {'aliceblue':'f0f8ff',
	'antiquewhite':'faebd7', 'aqua':'00ffff', 'aquamarine':'7fffd4',
	'azure':'f0ffff', 'beige':'f5f5dc', 'bisque':'ffe4c4', 'black':'000000',
	'blanchedalmond':'ffebcd', 'blue':'0000ff', 'blueviolet':'8a2be2',
	'brown':'a52a2a', 'burlywood':'deb887', 'cadetblue':'5f9ea0',
	'chartreuse':'7fff00', 'chocolate':'d2691e', 'coral':'ff7f50',
	'cornflowerblue':'6495ed', 'cornsilk':'fff8dc', 'crimson':'dc143c',
	'cyan':'00ffff', 'darkblue':'00008b', 'darkcyan':'008b8b',
	'darkgoldenrod':'b8860b', 'darkgray':'a9a9a9', 'darkgrey':'a9a9a9',
	'darkgreen':'006400', 'darkkhaki':'bdb76b', 'darkmagenta':'8b008b',
	'darkolivegreen':'556b2f', 'darkorange':'ff8c00', 'darkorchid':'9932cc',
	'darkred':'8b0000', 'darksalmon':'e9967a', 'darkseagreen':'8fbc8f',
	'darkslateblue':'483d8b', 'darkslategray':'2f4f4f', 'darkslategrey':'2f4f4f',
	'darkturquoise':'00ced1', 'darkviolet':'9400d3', 'deeppink':'ff1493',
	'deepskyblue':'00bfff', 'dimgray':'696969', 'dimgrey':'696969',
	'dodgerblue':'1e90ff', 'firebrick':'b22222', 'floralwhite':'fffaf0',
	'forestgreen':'228b22', 'fuchsia':'ff00ff', 'gainsboro':'dcdcdc',
	'ghostwhite':'f8f8ff', 'gold':'ffd700', 'goldenrod':'daa520',
	'gray':'808080', 'grey':'808080', 'green':'008000', 'greenyellow':'adff2f',
	'honeydew':'f0fff0', 'hotpink':'ff69b4', 'indianred':':cd5c5c',
	'indigo':':4b0082', 'ivory':'fffff0', 'khaki':'f0e68c', 'lavender':'e6e6fa',
	'lavenderblush':'fff0f5', 'lawngreen':'7cfc00', 'lemonchiffon':'fffacd',
	'lightblue':'add8e6', 'lightcoral':'f08080', 'lightcyan':'e0ffff',
	'lightgoldenrodyellow':'fafad2', 'lightgray':'d3d3d3', 'lightgrey':'d3d3d3',
	'lightgreen':'90ee90', 'lightpink':'ffb6c1', 'lightsalmon':'ffa07a',
	'lightseagreen':'20b2aa', 'lightskyblue':'87cefa', 'lightslategray':'778899',
	'lightslategrey':'778899', 'lightsteelblue':'b0c4de', 'lightyellow':'ffffe0',
	'lime':'00ff00', 'limegreen':'32cd32', 'linen':'faf0e6', 'magenta':'ff00ff',
	'maroon':'800000', 'mediumaquamarine':'66cdaa', 'mediumblue':'0000cd',
	'mediumorchid':'ba55d3', 'mediumpurple':'9370d8', 'mediumseagreen':'3cb371',
	'mediumslateblue':'7b68ee', 'mediumspringgreen':'00fa9a',
	'mediumturquoise':'48d1cc', 'mediumvioletred':'c71585',
	'midnightblue':'191970', 'mintcream':'f5fffa', 'mistyrose':'ffe4e1',
	'moccasin':'ffe4b5', 'navajowhite':'ffdead', 'navy':'000080',
	'oldlace':'fdf5e6', 'olive':'808000', 'olivedrab':'6b8e23',
	'orange':'ffa500', 'orangered':'ff4500', 'orchid':'da70d6',
	'palegoldenrod':'eee8aa', 'palegreen':'98fb98', 'paleturquoise':'afeeee',
	'palevioletred':'d87093', 'papayawhip':'ffefd5', 'peachpuff':'ffdab9',
	'peru':'cd853f', 'pink':'ffc0cb', 'plum':'dda0dd', 'powderblue':'b0e0e6',
	'purple':'800080', 'red':'ff0000', 'rosybrown':'bc8f8f',
	'royalblue':'4169e1', 'saddlebrown':'8b4513', 'salmon':'fa8072',
	'sandybrown':'f4a460', 'seagreen':'2e8b57', 'seashell':'fff5ee',
	'sienna':'a0522d', 'silver':'c0c0c0', 'skyblue':'87ceeb',
	'slateblue':'6a5acd', 'slategray':'708090', 'slategrey':'708090',
	'snow':'fffafa', 'springgreen':'00ff7f', 'steelblue':'4682b4',
	'tan':'d2b48c', 'teal':'008080', 'thistle':'d8bfd8', 'tomato':'ff6347',
	'turquoise':'40e0d0', 'violet':'ee82ee', 'wheat':'f5deb3', 'white':'ffffff',
	'whitesmoke':'f5f5f5', 'yellow':'ffff00', 'yellowgreen':'9acd32'
};

epages.validate.css.color2Hex = function (value) {
	value = value.toLowerCase();
	var rx;
	if (value.match(/transparent/i)) {
		// transparent
		return "transparent";
	} else if(value.match(/^\s*$|none/i)){
		//none
		return "none";
	} else if (value.match(/^#[0-9A-F]{6}$/i)) {
		// 6 digit hex rgb value (#1234FF or 1234FF)
		return value.toLowerCase();
	}	else if (epages.validate.css.validColors[value] !== undefined) {
		// known color name
		return '#' + epages.validate.css.validColors[value];
	} else if (rx = value.match(/^#([0-9A-F])([0-9A-F])([0-9A-F])$/i)) {
		// 3 digit hex rgb value (#123 or #FFF)
		return ("#" + rx[1] + rx[1] + rx[2] + rx[2] + rx[3] + rx[3]).toLowerCase();
	}	else if (rx = value.match(/^rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)$/i)) {
		// rgb values - pattern: "rgb(123,234,1)"
		return epages.lang.color.rgb2Hex({r: rx[1], g: rx[2], b: rx[3]}).toLowerCase();
	}	else {
		return false;
	}
};

epages.validate.css.isColor = function (value) {
	return epages.validate.css.color2Hex(value) !== false;
};

epages.validate.css.isSize = function (value, settings) {
	nbr_value= epages.string.cssSizeToNumber(value);
	if(nbr_value !== NaN && settings !== undefined) {
		if (settings.min && settings.max &&
			 (nbr_value < settings.min || nbr_value > settings.max)){
			 	return 'NOT_IN_RANGE';
			}

		if (settings.min != null && nbr_value < settings.min){ 
			return 'LOWER_THAN_MIN';
		}
		if (settings.max != null && nbr_value > settings.max){ 
			return 'GREATER_THAN_MAX';
		}
	}
	if (value.match(/^[0-9]+(px|pt)$/i)){
		return true;
	}
	if (value.match(/^[0-9]*\.?[0-9]+(pc|%|mm|cm|em|in|ex)$/i)){ 
		return true;
	}
	if (value.match(/^[0]+$/)){ 
		return true;
	}

	// comment.translate:NO_UNIT_VALUE,NO_UNIT,NO_NUMBER,FLOAT_NOT_ALLOWED,UNKNOWN_UNIT,UNKNOWN_ERROR
	if (value == ""){ 
		return 'NO_UNIT_VALUE';
	}
	if (value.match(/^[0-9]+$/)){ 
		return 'NO_UNIT';
	}
	if (!value.match(/^[0-9]*\.?[0-9]/)){ 
		return 'NO_NUMBER';
	}
	if (value.match(/^[0-9]*\.[0-9]+(?:px|pt)$/i)){ 
		return 'FLOAT_NOT_ALLOWED';
	}
	if (value.match(/^[0-9]*\.[0-9]$/)){ 
		return 'NO_UNIT';
	}
	if (value.match(/^[0-9]*\.?[0-9]+[a-z]+$/)){ 
		return 'UNKNOWN_UNIT';
	}
	return 'UNKNOWN_ERROR';
};

epages.validate.css.isWidth   = epages.validate.css.isSize;
epages.validate.css.isHeight  = epages.validate.css.isSize;
epages.validate.css.isPadding = epages.validate.css.isSize;
epages.validate.css.isMargin  = epages.validate.css.isSize;
