/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.validate.date $Revision: 1.8.4.1 $

*/
dojo.require('epages.epages');
dojo.provide('epages.validate.date');
dojo.require('epages.localize');
dojo.require('epages.string');
dojo.require('dojo.date.locale');

epages.validate.date.isTime = function(/*String*/timeString, /*String*/epagesPattern) {
	if (timeString == ''){
		return 'NO_VALUE';
	}
	var date;
	try {
		date = epages.string.toTime(timeString, epagesPattern);
	} catch (ex) {
		console.dir(ex);
		return 'INVALID_TIME';
	}
	// comment.translate:INVALID_TIME
	if (date === null){
		return 'INVALID_TIME';
	}
	return true;
};

epages.validate.date.isDate = function(/*String*/dateString, /*String*/epagesPattern) {
	if (dateString == ''){
		return 'NO_VALUE';
	}
	if (epagesPattern == null || epagesPattern.length == 0){
		epagesPattern = epages.vars.Locale.dateFormat;
	}
	var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
	try {
		var date = dojo.date.locale.parse(dateString, { selector: 'date', datePattern: pattern, timePattern: '' });
	} catch (ex) {
		return 'INVALID_DATE';
	}
	if (date === null){
		return 'INVALID_DATE';
	}
	return true;
};

epages.validate.date.isDateTime = function(/*String*/datetimeString, /*String*/epagesPattern) {
	if (datetimeString == ''){
		return 'NO_VALUE';
	}
	if (epagesPattern == null || epagesPattern.length == 0){
		epagesPattern = epages.vars.Locale.datetimeFormat;
	}
	var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
	try {
		var date = dojo.date.locale.parse(datetimeString, { selector: 'date', datePattern: pattern, timePattern: '' });
	} catch (ex) {
		return 'INVALID_DATETIME';
	}
	if (date === null){
		return 'INVALID_DATETIME';
	}
	return true;
};
