/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.validate.number $Revision: 1.5.4.1 $

*/
dojo.provide('epages.validate.number');

epages.validate.number.isInteger = function(value, settings) {
  if (settings == null){
    settings = {};
  }
  // convert to string
  value += '';

	// comment.translate:NO_VALUE,NO_INTEGER,NOT_IN_RANGE,LOWER_THAN_MIN,GREATER_THAN_MAX
  if (value == ''){
  	return 'NO_VALUE';
  }
  if (!(/^(?:0|-?[1-9][0-9]*)$/).test(value)){
  	return 'NO_INTEGER';
 	}
  value = Number(value);
  if ((settings.min != null && value < settings.min) ||
      (settings.max != null && value > settings.max)){
      	return 'NOT_IN_RANGE';
  }
  if (settings.min != null && value < settings.min){
  	return 'LOWER_THAN_MIN';
  }
  if (settings.max != null && value > settings.max){
  	return 'GREATER_THAN_MAX';
  }
  return true;
};
