/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.widget.CoverFlow $Revision: 1.2.4.3 $

*/
dojo.provide("epages.widget.CoverFlow");
dojo.require("epages.widget");
dojo.require("epages.browser");

dojo.declare("epages.widget.CoverFlow", [dijit._Widget], {

	imageData: [], /* public array for ExternalInterface access */
	coverFlowModuleSrc: dojo.moduleUrl('epages.widget', "templates/CoverFlow.swf"), // + "?" + String(Math.floor(Math.random()*9999)),

	_titleAttr: null,
	_currentWidth: 0,

	_buildCoverFlow: function() {
		this.srcNodeRef.title = this._titleAttr;
		this.srcNodeRef.innerHTML = "<object name='" + this.id + "_flash' id='" + this.id + "_flash' type='application/x-shockwave-flash' data='" + this.coverFlowModuleSrc + "'><param name='movie' value='" + this.coverFlowModuleSrc + "'/><param name='allowscriptaccess' value='always'/><param name='wmode' value='transparent'/></object>";
	},

	constructor: function() {
		this.imageData = [];
	},

	postMixInProperties: function() {
		var sourceNodes = dojo.query("a", this.srcNodeRef);
		for( var i=0,iLength=sourceNodes.length ; i<iLength ; i++ ) {
			var imageNode = sourceNodes[i].getElementsByTagName("img")[0];
			this.imageData.push([imageNode.getAttribute("src"), imageNode.getAttribute("longdesc"), sourceNodes[i].href, sourceNodes[i].getAttribute("href2"), (imageNode.getAttribute("ismap") ? true : false)]);
		}
		dojo.addClass(this.srcNodeRef, "HideElement");
	},

	postCreate: function() {
		this._titleAttr = this.srcNodeRef.title;
		setTimeout(dojo.hitch(this, function() {
			if(epages.Browser.flashVersion > 9) {
				if(this.imageData.length > 1) {
					this._buildCoverFlow();
					dojo.addClass(this.srcNodeRef, "Flashed");
					dojo.removeClass(this.srcNodeRef, "HideElement");
					this._currentWidth = this.srcNodeRef.offsetWidth;
					setInterval(dojo.hitch(this, function() {
						if(this._currentWidth != this.domNode.offsetWidth) {
							this._currentWidth = this.domNode.offsetWidth;
							this._buildCoverFlow();
						}
					}), 200);
				}else {
					dojo.removeClass(this.srcNodeRef, "HideElement");
					this.srcNodeRef.style.textAlign = "center";
					this.srcNodeRef.style.overflow = "hidden";
				}
			}else {
				dojo.removeClass(this.srcNodeRef, "HideElement");
			}
		}), 1);
	}

});