/*
Copyright (c) 2006-2007, epages Software GmbH
All Rights Reserved.

epages.widget.Dialog $Revision: 1.8.2.1 $

*/
dojo.provide("epages.widget.Dialog");
dojo.require("dijit.Dialog");
dojo.require("epages.browser");

dojo.declare(
"epages.widget.Dialog",
	[dijit.Dialog], {
		duration: epages.Browser.engine=="MSIE" ? 10 : 150,

		templateString:
			'<div class="dijitDialog ModalDialog" tabindex="-1">' +
					'<div dojoAttachPoint="titleBar" class="dijitDialogTitleBar" waiRole="dialog">' +
						'<span dojoAttachPoint="titleNode" class="dijitDialogTitle">${title}</span>' +
						'<span dojoAttachPoint="closeButtonNode" class="dijitDialogCloseIcon"  dojoAttachEvent="onclick: onCancel">' +
							'<span dojoAttachPoint="closeText" class="closeText">x</span>' +
						'</span>' +
					'</div>' +
					'<div class="LayerContent Border White">' +
						'<div dojoAttachPoint="containerNode" class="dijitDialogPaneContent"></div>' +
						'<div dojoAttachPoint="innerButtonBarNode" class="LayerInnerButtonBar" style="display:none"></div>' +
					'</div>' +
					'<div dojoAttachPoint="buttonBarNode" class="LayerButtonBar" style="display:none"></div>' +
			'</div>',


		postCreate: function() {
			this.inherited("postCreate",arguments);

			// hack to overlay applets
			if(epages.Browser.engine=="MSIE") {
				this.underlayIframe = document.createElement("iframe");
				this.underlayIframe.className="LayerIframe";
				this.underlayIframe.frameBorder="0";
				this.underlayIframe.src = "javascript:''";
			}
		},

		hide: function() {
			this.inherited("hide", arguments);
			if(epages.Browser.engine=="MSIE") {	// layer display corrections
				this.domNode.style.width="auto";
			}
		},

		show: function() {
			this.inherited("show", arguments);
			if(epages.Browser.engine=="MSIE") {	// layer display corrections
				this.domNode.style.width=this.domNode.offsetWidth+"px";
				this.domNode.style.overflow='hidden';
			}
			if(this.domNode && epages.zIndex){
				this.domNode.style.zIndex = epages.zIndex;
			}
			if(this._underlay){
				this._underlay.domNode.style.zIndex = this.domNode.style.zIndex-1;
			}
			if(epages.zIndex){
				epages.zIndex+=2;
			}
			//check if there is enough space to see the close button
			var popupTop = parseInt(this.domNode.style.top);
			var popupLeft = parseInt(this.domNode.style.left);
			if(popupTop < 0){
				this.domNode.style.top = "0px";
			}
			if(popupLeft < 0){
				this.domNode.style.left = "";
				this.domNode.style.right = "0px";
			}
			else {
				this.domNode.style.right = "";
			}
			//remove dragging
			if(this._moveable){
				this._moveable.destroy();
			}
		},

		_setup: function() {
			this.inherited("_setup", arguments);
			if(this._underlay){
				if(epages.Browser.engine=="MSIE") {
					this._underlay.node.appendChild(this.underlayIframe);
				} else {
					this._underlay.domNode.style.overflow= "auto"; // hack to overlay applets in ff
				}
			}
		}
	}
);


