/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.widget.Form $Revision: 1.2.4.8 $

*/

dojo.provide("epages.widget.Form");
dojo.require("epages.widget");

dojo.declare("epages.widget.Form", [dijit._Widget], {
		// summary:
		//					widget linked to the <form/> html element
		//					to enhance the functionality of that particular node

	submitButtons: 	[], 		// array of all submit buttons found inside of the form element on startup
									// you can push your dynamically built button in here hence it will be registered
	
	_formName: 		null,
	_elems:			{},
	_submits:		{},
	_invalides:		{},

	_onSubmit: function() {
		for( var i=0,iLength=this.submitButtons.length ; i<iLength ; i++ ) {
			this.submitButtons[i].disabled = true;
		}
	},

	postCreate: function() {
		this.inherited("postCreate", arguments);
		
		this.submitButtons = dojo.query("[type=submit]", this.domNode);
		
		this.connect(this.domNode, "submit", "_onSubmit");
		
		// for new formElements Widgets
		this._formName = dojo.attr( this.domNode , 'name' );
		dojo.connect(this.domNode, 'submit', this.validate);
	},
	
	validate: function(event) {
		var elems = this._elems;
		var error = false;
		
		for( var i in elems ) {
			error = elems[i].validate()==true ? error : true;
		};
		
		if( error ) {
			event.preventDefault();
		}
	},
	
	addElem: function( instance ) {
		if( instance.attr('type')=='submit' ) {
			this._submits[instance.id] = instance;
		}
		this._elems[instance.id] = instance;
	},
	
	removeElem: function( id ) {
		if( this._elems[id] ) {
			delete( this._elems[id] );
		}
		if( this._submits[id] ) {
			delete( this._submits[id] );
		}
	},
	
	change: function() {
		var elems = this._elems;
		var error = false;
		for( var i in elems ) {
			error = elems[i].attr('valide') ? error : true;
		}
		
		var elems = this._submits;
		for( var i in elems ) {
			elems[i].attr('disabled',error);
		}
	},
	
	destroy: function() {
		this.inherited('destroy', arguments);
		
		for( var i in elems ) {
			elems[i].destroy();
		}
	}
})