/*
	Copyright (c) 2006-2010, epages Software GmbH
	All Rights Reserved.

*/
dojo.provide("epages.widget.TabHandler");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.form.Button");
dojo.require("dijit.Toolbar");

dojo.declare("epages.widget.TabHandler",[dijit.layout.TabContainer], {
        widgetsInTemplate: true,
        childNodeIds: [],
        
        buildRendering: function(){
            this.inherited(arguments);
            if(this.srcNodeRef && this.srcNodeRef.innerHTML){
                this.addContent("Home",this.srcNodeRef.innerHTML);
            }
		},
        postCreate: function(){
            this.inherited(arguments);
            this.containerNode.id = "tabContainerNode";
        },
        closeAll: function(){
        	childNodeIds = [];
        	this.destroyDescendants();
        },
        closeOther: function(clickedChild){
        	var childs = this.getChildren();
        	for(var i=0,l=childs.length;i<l;i++){
        		if(clickedChild != childs[i]){
        			this.removeChild(childs[i]);
        		}
        	}
        },
		addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
			// Overrides _Container.addChild() to do layout and publish events
			this.inherited(arguments);
			if(this.tablist.pane2button && this.tablist.pane2button[child.id]){
				this.tablist.pane2button[child.id]._closeMenu.addChild(new dijit.MenuItem({
					label: "Close others",
					onClick: dojo.hitch(this, "closeOther",child)
				}));
				this.tablist.pane2button[child.id]._closeMenu.addChild(new dijit.MenuItem({
					label: "Close all",
					onClick: dojo.hitch(this, "closeAll")
				}));
			}
		},
		removeChild: function(/*Widget or int*/ widget){
			delete this.childNodeIds[widget.title];
			this.inherited(arguments);
		},
        addContent: function(/*String*/name,/*String*/html){
			if(!this.childNodeIds[name]){
	            var toolbar = new dijit.Toolbar({style:"background:none;border-bottom:0px;text-align:right;"});
	            //dM.startup();
	            var bC = new dijit.layout.BorderContainer({style: "height: 100%; width: 100%;",title: name,closable:"true"});
	            var cP = new dijit.layout.ContentPane({
	                content: html,
	                region: "center",
	                style: "background-color:#FFFFFF;"
	            });
	            bC.addChild(cP);
	            var cPDomNode = cP.domNode;
	            toolbar.addChild(new dijit.form.ToggleButton({iconClass:"iconPublic", showLabel:"true",checked:true, label:"Public",onChange:function(state){window.togglePublic(state,cPDomNode);}}));
	            toolbar.addChild(new dijit.form.ToggleButton({iconClass:"iconProtected", showLabel:"true",checked:true, label:"Protected",onChange:function(state){window.toggleProtected(state,cPDomNode);}}));
	            toolbar.addChild(new dijit.form.ToggleButton({iconClass:"iconPrivate", showLabel:"true",label:"Private",onChange:function(state){window.togglePrivate(state,cPDomNode);}}));
	            toolbar.addChild(new dijit.form.ToggleButton({iconClass:"iconInherited", showLabel:"true",label:"Inherited",onChange:function(state){window.toggleInherited(state,cPDomNode);}}));
	            cP = new dijit.layout.ContentPane({
	                content: toolbar,
	                region: "top",
	                style: "background-color:#FFFFFF;"
	            });
	            bC.addChild(cP);
	            this.addChild(bC,0);
	            bC.startup();
	            this.selectChild(bC);
	            this.childNodeIds[name]={cP:cPDomNode,bC:bC};
	            return cPDomNode;
			}else{
				this.selectChild(this.childNodeIds[name].bC);
				return this.childNodeIds[name].cP;
			}
        }
});