<?php

final class Freezer
{
  private $nodes;

  public function __construct() {
    $this->nodes = array();
  }

  public function __destruct() {
    unset($this->nodes);
  }
  public function isElement($key){
    $parts = explode(".",$key);
    $current = $this->nodes;
    foreach($parts as $part){
        $a = &$current[$part];  
        if(!$a){
            return false;
        }
        $current = $a;
    }          
    return true; 
  }
  public function open($key, $default) {    
    $parts = explode(".",$key);
    $current = $this->nodes;
    foreach($parts as $part){
        $a = &$current[$part];  
        if(!$a){
            return $default;
        }
        $current = $a;
    }          
    $res = $current["#value"];
    return $res? $res : $default;
  }
  public function save($key, $node=null) {  
    $parts = explode(".",$key);
    $current = &$this->nodes;
    foreach($parts as $part){
        $a = &$current[$part];
        if(!$a){
            $a = array();
        }
        $current = &$a;
    }          
    $current["#value"] = $node;
  } 
}
