<?php

require_once('Destructable.php');

class JavaScriptObject extends Destructable {
  protected $statement;
  protected $keys;
  public $line_number;
 
  public function getStatement(){
  	return $this->statement;
  }
  public function __construct($statement) {
    $this->statement = $statement;
    $this->line_number = $statement->line_number;
  }
  public function getLineNumber(){
  	if($this->statement){
  		return $this->statement->line_number;
  	}
  	return -1;
  }
  public function __destruct() {
    $this->mem_flush('statement', 'keys');
  }

  public function type() {
    return 'Object';
  }

  public function comments() {
    return $this->statement->comments;
  }

  public function values() {
    if (isset($this->keys)) {
      return $this->keys;
    }

    $keys = array();
    foreach ($this->statement->first as $value) {
      if (is_array($value)) {
        $value = $value[0];
      }
      $keys[$value->key][] = $value->convert();
    }

    return ($this->keys = $keys);
  }

  public function __toString() {
    return '(' . $this->type() . ')';
  }
  public function convertToString(){
    $args = $this->values(); 
    $result = "{";
    $c = count($args);
    foreach($args as $key => $value){
        if(count($value)){
            $classname = get_class($value[0]);
            switch($classname){
                case 'JavaScriptString':
                case 'JavaScriptLiteral':
                    $result .= $key.' : "'.$value[0]->convertToString().'"';
                    break;
                default:
                    $result .= $key.' : '.$value[0]->convertToString();
            }
            if($i < $c-1){
                $result .= ', ';
            }
        } 
    }
    return $result . "}";
  }
}