<?php

class JavaScriptOr extends JavaScriptVariable {
  protected $ors;
  public $line_number;

  public function __construct($ors,$line_number) {
    if (!is_array($ors)) {
      throw new Exception('JavaScriptOr expects to be passed an array');
    }
    $this->ors = $ors;
    $this->line_number = $line_number;
  }

  public function __destruct() {
    $this->mem_flush('ors');
  }

  public function types() {
    $mapped = array();
    foreach ($this->ors as $item) {
      $mapped[] = $item->type();
    }
    return $mapped;
  }

  public function type() {
    $types = array_diff($this->types(), array('variable'));
    if (count($types) == 1) {
      return array_pop($types);
    }
    // Assume that if one of them is a boolean, they all are
    if (in_array('bool', $types)) {
      return 'bool';
    }

    return 'Object';
  }
  public function convertToString(){
    $result = "";
    $c = count($ors);
    for($i = 0 ; $i<$c; $i++){
        $value = $args[$i];
        $classname = get_class($value);
        switch($classname){
            case 'JavaScriptString':
            case 'JavaScriptLiteral':
                $result .= '"'.$value->convertToString().'"';
                break;
            default:
                $result .= $value->convertToString();
        }
        if($i < $c-1){
            $result .= ' || ';
        }
    }
    return $result;
  }
}