<?php

ini_set('display_errors', 1);
error_reporting(E_ALL ^ E_NOTICE);

require_once('JavaScriptLanguage.php');
require_once('JavaScriptParser.php');
require_once('JavaScriptStatements.php');
require_once('JavaScriptFunction.php');
require_once('Dojo.php');
require_once('DojoCommentBlock.php');

function ConvertToStoreFormat($fullstring,$name,$childs){
	$obj = array('label' => $name,'fullstring'=>$fullstring."/".$name,"id"=>$childs["#INDEX"]);
	if(count($childs)>1){
		$obj['children'] = array();
		foreach($childs as $child => $val){
			if($child == "#INDEX") continue;
			$obj['children'][] = ConvertToStoreFormat($fullstring."/".$name,$child,$val);
		}
	}
	return $obj;
}
function createIndex($id,$node,&$counter){
	$res = array();
	foreach($node['#children'] as $childid => $child){
		if($child['sourceLocation']){
			$res[] = array(
				id		=> $counter++,
				label	=> $id .".".$childid,
				file	=> $child['sourceLocation']
			);
		}
	}
	return $res;
}
function getChildren($id, &$node, &$nodes,$roots,&$superclassChain=array()){
  $parts = explode('.', $id);
  $keysToCopy = array('summary','description','examples');
  if($node!=NULL){
      if(!$node['*computed']){
          if($node['chains'] && $node['chains']['prototype']){
              $superclass = $node['chains']['prototype'][0];
              if($node['chains']['call']){
                 array_shift($node['chains']['call']); 
              }
              if($superclass){
                  $superNode = $nodes->open($superclass, null);
                  getChildren($superclass,$superNode,$nodes,$roots,$superclassChain);
                  $superclassChain[] = $id;  
                  if($superNode){
                      $superChilds = $superNode['#children'];
                      foreach($superChilds as $child_id => $superChild){
                          if($node['#children'][$child_id]){
                              if($superChild['inherited']){
                                $node['#children'][$child_id]['overrides'] = $superChild['inherited'].".".$child_id;
                              } else {
                                $node['#children'][$child_id]['overrides'] = $superclass.".".$child_id;
                              }
                              foreach($keysToCopy as $key){
                              	if($superChild[$key] && !$node['#children'][$child_id][$key]){
                              		$node['#children'][$child_id][$key] = $superChild[$key];
                              	}
                              }
                          } else {
                              $node['#children'][$child_id] = $superChild;
                              if(!$node['#children'][$child_id]['inherited']){
                                  $node['#children'][$child_id]['inherited'] = $superclass;
                              }
                          }
                      }
                  }
              }
              $node['chains']['prototype'][0] = $superclassChain;
          } else {
              if(!$node['chains']){
                  $node['chains'] = array();
              }
              if(!$node['chains']['prototype']){
                  $node['chains']['prototype'] = array();
              }
              $node['chains']['prototype'][] = array($id);
          }
          $node['*computed'] = true;
          $nodes->save($id,$node);
      } else {
        $superclassChain = $node['chains']['prototype'][0];
      }
  } else {
      $superclassChain[] = $id;
  }
}

$_dojo_properties_modules = array();
function get_attach_points($namespace, $file_name,$name){
  if (function_exists($namespace . '_code_location')) {
    $location = _dojo_ensure_directory(call_user_func($namespace . '_code_location'));
  } 
  else {
    return array();
  }
  $location = substr($location,0,strpos($location,$namespace));
  $lines = file_get_contents($location . $file_name);
  $result = array();
  if(count($lines)){
      preg_match_all("/dojoAttachPoint=\"(.*?)\"/",$lines,$matches);
      foreach($matches[1] as $index=>$match){
          $splited = explode(",",$match);
          foreach($splited as $split){
            $result[] = $name.".".$split;
          }
      }
  }
  return $result;
}
function is_in_array($object_name,$objectsToRemove){
    if(count($objectsToRemove)==0){
        return false;
    }
    $length = count(explode(".",$objectsToRemove[0]));
    $object_name_cut = implode(".",array_slice(explode(".",$object_name),0,$length));
    return in_array($object_name_cut,$objectsToRemove);
}              
function _dojo_get_namespaces($limit=null){
  static $namespaces;
  if (!isset($namespaces)) {
    $namespaces = array();
    $modules = explode(",",$GLOBALS['settings_ini']['DocSettings']['modules']);
    $files = scandir('modules');
    foreach ($files as $file) {
      $found = false;
      foreach($modules as $id=>$module){
      	if(substr($file,0,strlen($module)) == $module){
      		$found = true;
      		unset($modules[$id]);
      		break;
      	}
      }
      if(!$found){
      	continue;
      }
      if (substr($file, -7) == '.module') {
        $namespace = substr($file, 0, -7);
        if (!$limit || in_array($namespace, $limit)) {
          include_once('modules/' . $file);
          $namespaces[] = substr($file, 0, -7);
        }
      }
      elseif (substr($file, -18) == '.module.properties') {
        $namespace = substr($file, 0, -18);
        if (!$limit || in_array($namespace, $limit)) {
          global $_dojo_properties_modules;
          foreach (preg_split('%[\n\r]+%', file_get_contents('modules/' . $file)) as $line) {
            list($line, ) = preg_split('%[!#]%', $line, 2);
            if ($line = trim($line)) {
              list($key, $line) = explode('=', $line, 2);
              $key = str_replace('\\ ', ' ', trim($key));
              $line = preg_replace('%^\s+%', '', $line);
              if ($key == 'location') {
                $line = _dojo_ensure_directory($line);
              }
              $_dojo_properties_modules[$namespace][$key] = $line;
            }
          }
          $namespaces[] = substr($file, 0, -18);
        }
      }
    }
  }
  return $namespaces;
}

function dojo_get_include($node, $provide) {
  if ($node->jsdoc_project_name == $provide->title) {
    return 'Included automatically';
  }
  else {
    return 'dojo.require("%s");';
  }
}

function _dojo_ensure_directory($directory) {
  if (!is_dir($directory)) {
    die("$directory is not a directory\n");
  }
  else {
    if(substr($directory, -1) != '/'){
      $directory .= '/';
    }
  }
  return $directory;
}

function dojo_get_file_time($namespace, $file) {
  if (function_exists($namespace . '_code_location')) {
    return filectime(_dojo_ensure_directory(call_user_func($namespace . '_code_location')) . $file);
  }
  else {
    global $_dojo_properties_modules;
    return filectime($_dojo_properties_modules[$namespace]['location'] . $file);
  }
}

function _jsdoc_file_list($dir = false, $recurse = false){
  $output = array();

  if (!$recurse) {
    $old_dir = getcwd();
    if (!is_dir($dir)) {
      return array();
    }
    chdir($dir);
    $dir = '.';
  }
  $files = scandir($dir);

  foreach ($files as $file) {
    if ($file{0} == '.') continue;
    if (is_dir($dir . '/' . $file)) {
      if ($recurse) {
        $file = $dir . '/' . $file;
      }
      $output = array_merge($output, _jsdoc_file_list($file, true));
    }else{
      if (substr($file, -3) == '.js' && substr($file, -6) != '.xd.js') {
        if ($recurse) {
          $file = $dir . '/' . $file;
        }
        $output[] = $file;
      }
    }
  }

  if (!$recurse) {
    chdir($old_dir);
  }
  return $output;
}

function dojo_get_files($limit=null) {
    $namespaces = _dojo_get_namespaces($limit);
    $files = array();
    foreach ($namespaces as $namespace) {
        if (function_exists($namespace . '_code_location')) {
          $location = _dojo_ensure_directory(call_user_func($namespace . '_code_location'));
        }
        else {
          global $_dojo_properties_modules;
          $location = $_dojo_properties_modules[$namespace]['location'];
        }
        if (!$location) die($namespace . '_code_location does not return useful result');
        $list = _jsdoc_file_list($location);
        foreach ($list as $i => $item) {
            // Skip internationalization/tests/demos files
            if (preg_match('%(^|/|\\\\)(nls|tests|demos|_test)(\\\\|/)%', $item) || 
                preg_match('%_test\..*?$%', $item)) {
              unset($list[$i]);
              continue;
            }
            $list[$i] = array($namespace, $item);
        }
        $files = array_merge($files, array_values($list));
    }

    return $files;
}

function dojo_get_contents($namespace, $file_name) {
  if(!$GLOBALS["packageDeclares"]) $GLOBALS["packageDeclares"] = array();
  if (function_exists($namespace . '_code_location')) {
    $location = _dojo_ensure_directory(call_user_func($namespace . '_code_location'));
  }
  else {
    global $_dojo_properties_modules;
    $location = $_dojo_properties_modules[$namespace]['location'];
  }

  $lines = preg_replace('%/\*={3,}|={3,}\*/%', '', file_get_contents($location . '/' . $file_name));
  $parser = new JavaScriptParser(JavaScriptLanguage::tokenize($lines),$GLOBALS['settings_ini']['WarnSettings']['maxComplexity']);
  $package = new JavaScriptStatements($parser->statements());

  $output = array();
  
  // Handle console.debug calls
  $functionCalls = $package->function_calls(FALSE,NULL,TRUE);
  foreach ($functionCalls as $call) {
  	switch($call->name()){
  		case "console.debug":
  			$GLOBALS["warning"]->registerWarning("consoleDebug","debug message: remove console.debug",$call->getLine(),$call->getLineNumber());
  			break;
  		case "eval":
  			$GLOBALS["warning"]->registerWarning("eval","perf warning: avoid using eval()",$call->getLine(),$call->getLineNumber());
  			break;
  		case "with":
  			$GLOBALS["warning"]->registerWarning("with","style warning: avoid using with()",$call->getLine(),$call->getLineNumber());
  			break;
  		case "alert":
  			$GLOBALS["warning"]->registerWarning("alert","debug message: avoid using alert()",$call->getLine(),$call->getLineNumber());
  			break;
  		case "window.setTimeout":
  			$arguments = $call->arguments();
  			if($arguments->length>1 && $arguments->get(1)->value() == "1"){
	  				break;
  			}
  			$GLOBALS["warning"]->registerWarning("setTimeout","style warning: avoid using timeouts",$call->getLine(),$call->getLineNumber());
  			break;
  		case "window.setInterval":
  			$callscall = $call->getCall();
  			$intervalComment = $parser->comments_before($callscall,true,true);
  			if(!count($intervalComment)){
  				$GLOBALS["warning"]->registerWarning("commentInterval","style warning: intervals should be commented",$call->getLine(),$call->getLineNumber());
  			}
      		if(($pos = $callscall->token_pos) && ($pos<2 || $parser->tokens[$pos-2]['value'] != "=")){
        		$GLOBALS["warning"]->registerWarning("setInterval","perf warning: save interval id and use clearInterval",$call->getLine(),$call->getLineNumber());
      		}
  			break;
  	}
  }
  
  // Handle dojo.provide calls
  foreach ($package->function_calls(TRUE, 'dojo.provide') as $call) {
    if ($module = $call->arguments()->getString(0)) {
      $output['#provides'] = $module;
    }
  }
  $output['#resource'] = $file_name;

  // Handle dojo.require calls
  foreach ($package->function_calls(TRUE, 'dojo.require') as $call) {
    if ($module = $call->arguments()->getString(0)) {
      $output['#requires'][] = $module;
    }
  }

  // Handle mixin/extend calls
  foreach ($package->function_calls(TRUE, 'dojo.mixin', 'dojo.extend') as $call) {
    $arguments = $call->arguments();
    $assignment = $call->assignment();
    $root = NULL;
    if ($constructor = $arguments->getFunction(0)) {
      if ($assignment) {
        Dojo::roll_out($constructor, $assignment, FALSE, $output);
      }
    }
    else {
      $root = $arguments->getVariable(0, TRUE);
      if ($call->name() == 'dojo.extend') {
        $output[$root]['type'] = 'Function';
      }
    }

    foreach (array_diff(array_unique(array($assignment, $root)), array(NULL)) as $root) {
      $mixin = $call->name() == 'dojo.mixin';
      for ($i = 1; $i < $arguments->length; $i++) {
        if ($arguments->getObject($i)) {
          $keys = array();
          foreach ($arguments->getObject($i)->values() as $key => $values) {
            $keys[] = $key;
            $full_name = "$root.$key";
            foreach ($values as $value) {
              if ($value instanceof JavaScriptVariable) {
                $key = $mixin ? $full_name : "$root.prototype.$key";
                if ($key != $value->value()) {
                  $output[$key]['alias'] = $value->value();
                }
              }
              else {
                Dojo::roll_out($value, $full_name, FALSE, $output);
                $output[$full_name][$mixin ? 'attached' : 'prototype'] = $root;
              }
            }
          }
          Dojo::roll_out_comment_block($arguments->getObject($i), $root, $output, $keys);
        }
        elseif ($root && $full_name = $arguments->getVariable($i)) {
          if ($mixin) {
            $output[$root]['mixins']['normal'][] = $full_name;
          }
          else {
            $output[$root]['chains']['prototype'][] = $full_name;
          }
        }
      }
    }
  }
  $objectsToRemove = array();
  foreach ($package->function_calls(TRUE, 'dojo.declare') as $call) {
    $arguments = $call->arguments();
    $name = $arguments->getString(0);
    $nameparts = explode(".",$name);
    if(count($nameparts)){
    	if(!array_key_exists($nameparts[0], $GLOBALS["packageDeclares"])){
    		$GLOBALS["packageDeclares"][$nameparts[0]] = array();
    	}
    	$GLOBALS["packageDeclares"][$nameparts[0]][] = $name;
    }
    if (!$name) {
      continue;
    }
    $output[$name]['type'] = 'Function';
    if ($superclass = $arguments->getVariable(1)) {
      if ($superclass != 'null') {
        $output[$name]['chains']['prototype'][] = $superclass;
        $output[$name]['chains']['call'][] = $superclass;
      }
    }
    elseif ($superclasses = $arguments->getArray(1)) {
      for($i = 0; TRUE; $i++) {
        if ($superclass = $superclasses->getVariable($i)) {
          $output[$name]['chains']['prototype'][] = $superclass . ($i ? '.prototype' : '');
          $output[$name]['chains']['call'][] = $superclass;
        }
        else {
          break;
        }
      }
    }
    if ($mixin = $arguments->getObject(2)) {
      $mixinStatements = new JavaScriptStatements($mixin->getStatement());
      foreach ($mixinStatements->function_calls(FALSE,NULL,TRUE) as $call) {
      	if($call->name()=="dojo.connect"){
	      	$callscall = $call->getCall();
	      	if(($pos = $callscall->token_pos) && ($pos<2 || $parser->tokens[$pos-2]['value'] != "=")){
	        	$GLOBALS["warning"]->registerWarning("dojoConnectWidget","perf warning: replace dojo.connect with this.connect",$call->getLine(),$call->getLineNumber());
	      	}
      	}
      }
      $keys = $block_keys = Dojo::$block_keys;
      $new_keys = array();
      $constructors = array();
      // Remember that bad code can have multiple matching keys
      foreach ($mixin->values() as $key => $values) {
        $new_keys[] = $key;
        $full_name = "$name.$key";
        foreach ($values as $value) {
          if($value->line_number){
          	$output[$full_name]['#LineNumber'] = $value->line_number;
          }
          if ($value instanceof JavaScriptFunction) {
            if (in_array($key, array('constructor', 'preamble', 'postscript'))) {
              $output[$full_name]['constructor'] = $key;
              $output[$full_name]['prototype'] = $name;
              $constructors[$full_name] = $value;
              continue;
            }
          }
          elseif ($value->type() == 'variable') {
            if ($full_name != $value->value()) {
              $output[$full_name]['alias'] = $value->value();
            }
            continue;
          } else if($key == "templatePath" && $value instanceof JavaScriptFunctionCall){
                $call_arguments = $value->arguments();
                $a = $call_arguments->getString(0);
                $b = $call_arguments->getString(1);    
                if($a && $b){
                    $output[$name]["attachPoints"] = get_attach_points($namespace,str_replace(".","/",$a) ."/". $b,$name);
                    $objectsToRemove = array_merge($objectsToRemove,$output[$name]["attachPoints"]);    
                }  
          } else {
          		$initv = $value->convertToString();
          		if($initv !== null){
                	$output[$full_name]['initialValue'] = $initv;
          		}
          }
          $output[$full_name]['prototype'] = $name;
          $new_keys = array_unique(array_merge($new_keys, Dojo::roll_out($value, $full_name, FALSE, $output, $new_keys)));
        }
      }
      foreach ($constructors as $full_name => $constructor) {
        $new_keys = array_unique(array_merge($new_keys, Dojo::roll_out($constructor, $name, FALSE, $output, $new_keys)));
        foreach ($output[$name] as $key => $value) {
          if ($key != 'chains') {
            $output[$full_name][$key] = $value;
          }
        }
      }

      Dojo::roll_out_comment_block($mixin, $name, $output, $new_keys);
      foreach($output as $name=>$key){
      	if(is_array($key) && array_key_exists('inferred_type', $key) && ($line_number = $key['#LineNumber'])){
      		$objName = array_pop(explode(".",$name));
      		$visbility = ($objName && $objName[0]=="_")?"Private":"Public";
      		if($key['inferred_type']=="Function"){
      			if(!array_key_exists('summary', $key)){
      				$GLOBALS["warning"]->registerWarning("DocFuncSummary".$visbility,"docu: missing function summary ",$objName,$line_number);
      			}
      			if(array_key_exists('parameters', $key)){
      				foreach($key['parameters'] as $parameter){
      					if(!array_key_exists('type', $parameter)){
      						$GLOBALS["warning"]->registerWarning("DocFuncParameterType".$visbility,"docu: missing parameter type ",$objName,$line_number);
      					}
      				}
      			}
      		}else{
      		    if(!array_key_exists('summary', $key)){
      				$GLOBALS["warning"]->registerWarning("DocPropertySummary".$visbility,"docu: missing property summary ",$objName,$line_number);
      			}
      		    if(!array_key_exists('type', $key)){
      				$GLOBALS["warning"]->registerWarning("DocPropertyType".$visbility,"docu: missing property type ",$objName,$line_number);
      			}
      		}
      	}
      }
    }
  }

  // Variable assignments (global)
  foreach ($package->assignments(TRUE) as $variable) {
    foreach ($variable->names() as $name) {
      $parts = explode('.', $name);
      $name = implode('.', array_diff($parts, array('prototype')));
      $last = array_pop($parts);

      $is_prototype = ($last == 'prototype');

      Dojo::roll_out($variable->value(), $name, FALSE, $output, array(), $is_prototype);

      if (count($parts) && !$is_prototype) {
        $output[$name]['attached'] = implode('.', $parts);
      }
    }
  }

  // dojo.provide creates new objects if needed
  if (!empty($output['#provides'])) {
    $parts = explode('.', $output['#provides']);
    while (count($parts)) {
      if (!array_key_exists(implode('.', $parts), $output)) {
        $output[implode('.', $parts)] = array('type' => 'Object');
      }
      array_pop($parts);
    }
  }

  // Set privacy, classlikeness, and clean up the summary a bit
  foreach ($output as $object_name => $object) {
    if ($object_name{0} == '#') {
      continue;
    }
    if (is_in_array($object_name,$objectsToRemove)){
        unset($output[$object_name]); 
        continue;
    }
    $parts = explode('.', $object_name);
    $last = array_pop($parts);
    if ($last{0} == '_') {
      $output[$object_name]['private'] = true;
    }
    if (preg_match('%\._+[^A-Z]%', implode('.', $parts), $match)) {
        $output[$object_name]['private_parent'] = true;
    }
    if (is_array($object['tags'])) {
      foreach ($object['tags'] as $tag) {
        if ($tag == 'protected') {
          unset($output[$object_name]['private']);
          $output[$object_name]['protected'] = true;
        }
        elseif ($tag == 'private') {
          unset($output[$object_name]['protected']);
          $output[$object_name]['private'] = true;
        }
        elseif ($tag == 'deprecated') {
          $output[$object_name]['deprecated'] = true;
        }
      }
      $output[$object_name]['tags'] = array_diff($object['tags'], array('private', 'protected', 'deprecated'));
    }

    if (isset($object['inferred_type'])) {
      if (empty($object['type'])) {
        $output[$object_name]['type'] = $object['inferred_type'];
      }
      unset($output[$object_name]['inferred_type']);
    }

    if ($object['type'] == 'Function') {
      if (preg_match('%^(_*)[A-Z]%', $last, $match)) {
        if (strlen($match[1]) < 2) {
          unset($output[$object_name]['private']);
        }
        $output[$object_name]['classlike'] = true;
      }
    }

    if ($object['prototype'] && $output[$object['prototype']]) {
      $output[$object['prototype']]['classlike'] = true;
    }
    elseif ($object['instance'] && $output[$object['instance']]) {
      $output[$object['instance']]['classlike'] = true;
    }
  }
  foreach ($output as $object_name => &$object) {
    if ($object_name{0} == '#') {
      continue;
    }
    $object["#SourceLocation"] = $GLOBALS["warning"]->currentFile;
    $parts = explode('.', $object_name);    
    while(!empty($parts)){
      foreach ($output as $object_name2 => $object2) {
          if ($object_name{0} == '#' || $object_name2 == $object_name) {
              continue;
          }
          if($object_name2 == implode('.',$parts) && $object2["type"] == "Array"){
              unset($output[$object_name]);
              break 2;
          }
      }
      array_pop($parts);
    }
  }
  return $output;
}