<?php   
class warn {
  public $quiet = 0;
  public $currentFile = NULL;
  public $warnings_count = array(); 
  public $errors = array();
  public $enabledWarnings = array();
  public function setEneabledWarnings($a){
  	$this->enabledWarnings = $a;
    foreach($a as $key=>$value){
    	if($value!=="DISABLED"){
       		$this->warnings_count[$key] = 0;
    	}
    }
  }
  public function registerWarning($id,$text,$line,$line_number=null){
  		$namespace = explode("/",$this->currentFile);
        if($this->quiet<2 && count($namespace) && $namespace[0] == "epages"){
            if($this->enabledWarnings[$id] !== "DISABLED"){
            	if($line_number){
					$this->errors[] = array(
						"file"    => $this->currentFile,
						"line"    => $line_number,
						"message" => $text
					);
            	} else {
            		// printf("MISSING LINE NUMBER: %s IN: %s\n",$id,$this->currentFile);
            	}
            	if($this->enabledWarnings[$id] === "ERROR"){
            		$GLOBALS['print']->out("\n".$this->currentFile."\n\tERROR ".$text." AT LINE ".$line_number.": \n\t\t".$line."\n",1);
            	}
                $this->warnings_count[$id]++;
            }elseif($this->enabledWarnings[$id] === NULL){
                // printf("MISSING PROPERTY IN WARNINGS: %s\n",$id);
            }  
        }
  }
  private function getFolderName($fileName){
		// Extract the folder name from a file name
		$idx = strripos($fileName,"/");
		return substr($fileName,0, $idx);
  }
 private function pushFolder($folderName,&$folders,&$json,&$ids){
		if(!$folders[$folderName]){
			$folders[$folderName] = true;
			$json[] = "{id: '" .($ids++) . "', file: '" . $folderName . "', folder: 1}";
		}
  }
  public function consoleReport(){
  	$GLOBALS['print']->out("#|\n\nAmount of Warnings: \n",0);  
	$s = 0;
	foreach($GLOBALS["warning"]->warnings_count as $key=>$value){
		$GLOBALS['print']->out("\t".$key.": ".$value."\n", 0); 
		$s+=$value;
	} 
	$GLOBALS['print']->out("TOTAL: ".$s."\n", 0); 
  }
  public function generateReport(){
  	if($this->quiet<2){
		$ids = 1;
		$json = array("{id:'" .($ids++) . "', file: 'All', isFolder:true}");
	
		// A map of folders that have already been found.
		$allFolders = array();
		
		$messageIds = array();
		$messageCounter = 1;
		
		// Add a folder to the list of folders.
		foreach($this->errors as $err){
			$message = $err['message'];
			$messageId = $messageIds[$message];
			if(!$messageId){
				$messageId = "m" . $messageCounter++;
				$messageIds[$message] = $messageId;
				
				$json[] = "{id:'" . $messageId . "',msg:'" . $message . "'}";
			}
		}
		
		$this->pushFolder("All",$allFolders,$json,$ids);
		
		// Create the JSON records for each error.
		foreach($this->errors as $err){
			$folderName = $this->getFolderName($err['file']);
			$this->pushFolder($folderName,$allFolders,$json,$ids);
			
			$json[] = "{id:'" .($ids++) . 
						"', file:'" . $err['file'] .
						"',line:" . $err['line'] . 
						",msg:{'_reference':'" . $messageIds[$err['message']] . 
						"'},folder: 0" .
						"}";
		}
	
		// Add the date that the check was run to the store.
		$json[] = "{id:'" .($ids++) ."', date: " .time(). "}";
		
		// Save the file.
		$fh = fopen("checkstyleData.js", 'w');
		
		$json = "{ identifier: 'id', label:'file', items: [" . implode(",\n",$json) . "]}";
		fwrite($fh, stripslashes($json));
		fclose($fh);	
  	}				
  }
    
}
$GLOBALS["warning"] = new warn();
?>
