/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.clipfish');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.ClipFish = epages.Class();

dojo.extend(
	epages.cartridges.de_epages.externalcontent.ClipFish,
	epages.cartridges.de_epages.design.MceContent.prototype, 
	{
		contentClass    : 'epages.cartridges.de_epages.externalcontent.ClipFish',
		title           : 'ClipFish',
		clipFishInput   : '',
		width           : 425,
		height          : 350,
		autostart				: '0',
		size            : 'large',
		objectlink			: 'http://www.clipfish.de/cfng/flash/clipfish_player_3.swf?videoid=',
		embededlink     : 'http://www.clipfish.de/cfng/flash/clipfish_player_3.swf?vid=',
		preview         : epages.vars.StoreRoot + '/BO/icons/navelement_clipfish.png',
		directPreview   : false,
		messageWidget   : undefined,
		translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),
	
		info: function () {
			var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
			dojo.mixin(info, {
				clipFishInput  : this.clipFishInput,
				size          : this.size
			});
			return info;
		},
		saveForm: function() {
			if (this.form !== undefined){
				this.formData = (new epages.html.Form(this.form)).get();
			}
			if(this.formData.get('videosize')[0] == "large"){
				this.width = 425;
				this.height = 350;
			}
			else{
				this.width = 300;
				this.height = 250;
			}
			if(this.formData.get('autostart')[0]){
				this.autostart = '1';
			}else{
				this.autostart = '0';
			}
	
		},
		_checkRegEx: function(string, regex) {
			var videoid = regex.exec(string);
	
			if(videoid != "" && videoid != null && videoid[1]) {
				return videoid[1];
			}
			return null;
		},
	
		_getObjectVideoId: function(input){
			// summary: RegExes the Object video id from clipfish video code.
	
			//RegExp to find videoid in embed
			var videoid = this._checkRegEx(input,/vid=([\w-]+)/);
	
			if(videoid == null || videoid == ''){
				//RegExp to find videoid in URL
				videoid = this._checkRegEx(input,/videoid=([\w-]+)/);
			}
	
			if(videoid == null || videoid == ''){
				//RegExp to find videoid in URL2
				videoid = this._checkRegEx(input,/\/video\/([\w-]+)/);
			}
	
			if(videoid != "" && videoid != null){
				return videoid;
			}else{
				return false;
			}
		},
	
		contentString: function (info, ispreview) {
			if(info.formData.get('clipFishInput')){
				info.clipFishInput = info.formData.get('clipFishInput')[0];
	
				var objectvideoid = this._getObjectVideoId(info.clipFishInput);
	
				if(objectvideoid === false){
					if(this.messageWidget == undefined) {
						var message = new epages.widget.Message({
									headline:this.translation.get('Error'),
									message:this.translation.get('clipFishError'),
									sizeClass:"Large",
									typeClass:"Warning"
								});
						this.messageWidget = new epages.widget.Modaldialog({
							options:{
								title : this.translation.get('Error'),
								content : message
							},
							buttons: [{
								label: this.translation.get('OK'),
								cssClass: 'Active',
								onclick: function() {
								this._modalDialogWidget.hide();
								}
							}]
						});
					}
					document.body.appendChild(this.messageWidget.domNode);
					this.messageWidget.show();
					return "&nbsp;";
				}
				else{
					info.formData._data['clipFishInput'] = ['vid='+objectvideoid];
					var output = '<object width="'+info.width+'" height="'+info.height+'" id="player" align="middle"><param name="movie" value="'+this.objectlink+objectvideoid+'&as='+info.autostart+'" /><param name="allowFullScreen" value="true" /><embed src="'+this.embededlink+objectvideoid+'&as='+info.autostart+'" quality="high" width="'+info.width+'" height="'+info.height+'" name="player" align="middle" allowFullScreen="true"></embed></object>';
	
					if(document.getElementsByName('clipFishInput').length != 0) {
						document.getElementsByName('clipFishInput')[0].value = output;
					}
					return output;
				}
			}
			else{
				return "&nbsp;";
			}
		},
		mceInsertContent: function(info){
			if (info === undefined) {
				info = this.info();
			}
			var objectvideoid = this._getObjectVideoId(info.formData.get('clipFishInput')[0]);
	
			info.formData._data['clipFishInput'] = ['vid='+objectvideoid];
			epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
		}
	}
);

