/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.cultclip');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.CultClip = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.CultClip,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.CultClip',
	title           : 'CultClip',
	cultClipInput   : '',
	width           : 470,
	height          : 406,
	autostart				: 'false',
	loop						: 'false',
	size            : 'large',
	embededlink     : 'http://www.cultclip.tv/ostubeplayer.swf?hosturl=http://www.cultclip.tv/&themecolor=0x000000&symbolcolor=0xffffff&backgroundcolor=0x000000&overlay=http://www.cultclip.tv//media/custom/player_emb.png&mediaid=',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_cultclip.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			cultClipInput : this.cultClipInput,
			size          : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}

		if(this.formData.get('loop')[0]){
			this.loop = 'true';
		}else{
			this.loop = 'false';
		}
		if(this.formData.get('autostart')[0]){
			this.autostart = 'true';
		}else{
			this.autostart = 'false';
		}
	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /video\/([\w-]+)/;//RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /mediaid=([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('cultClipInput')){
			info.cultClipInput = info.formData.get('cultClipInput')[0];
			var videoid = this._getVideoId(info.cultClipInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('cultClipError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('cultClipInput').length != 0){
					document.getElementsByName('cultClipInput')[0].value = 'mediaid='+videoid;
				}
				info.formData._data['cultClipInput'] = ['mediaid='+videoid];
  			var finalLink = this.embededlink+videoid+'&autostart='+info.autostart+'&loop='+info.loop;
  			return '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" width="'+info.width+'" height="'+info.height+'" id="player" align="middle"><param name="allowScriptAccess" value="always" /><param name="movie" value="'+finalLink+'" /><param name="quality" value="high" /><param name="bgcolor" value="#000000" /><param name="width" value="'+info.width+'" /><param name="height" value="'+info.height+'" /><param name="scale" value="noscale" /><param name="allowFullScreen" value="true" /><embed src="'+finalLink+'" quality="high" bgcolor="#000000" height="'+info.height+'" width="'+info.width+'" name="player" align="middle" allowFullScreen="true" allowScriptAccess="always" scale="noscale" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer"></embed></object>';
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){ 
			var info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('cultClipInput')[0]);
		info.formData._data['cultClipInput'] = ['mediaid='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});