/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.dailymotion');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.DailyMotion = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.DailyMotion,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.DailyMotion',
	title           : 'DailyMotion',
	dailyMotionInput: '',
	width           : 470,
	height          : 406,
	size            : 'large',
	embededlink     : 'http://www.dailymotion.com/swf/',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_dailymotion.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			dailyMotionInput 	: this.dailyMotionInput,
			size          		: this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}
	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /swf\/([\w-]+)/;//RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /video\/([\w-]+)/;//RegExp to find videoid in embed
			videoid = RegExp2.exec(input);
		}
		if(videoid == null || videoid == ''){
			var RegExp3 = /v=([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp3.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('dailyMotionInput')){
			info.dailyMotionInput = info.formData.get('dailyMotionInput')[0];
			var videoid = this._getVideoId(info.dailyMotionInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('dailyMotionError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('dailyMotionInput').length != 0){
					document.getElementsByName('dailyMotionInput')[0].value = 'v='+videoid;
				}
				info.formData._data['dailyMotionInput'] = ['v='+videoid];
  			var finalLink = this.embededlink+videoid;
  			return '<object width="'+info.width+'" height="'+info.height+'"><param name="movie" value="'+finalLink+'" /><param name="allowFullScreen" value="true" /><param name="allowScriptAccess" value="always" /><embed src="'+finalLink+'" type="application/x-shockwave-flash" width="'+info.width+'" height="'+info.height+'" allowFullScreen="true" allowScriptAccess="always"></embed></object>';
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){ 
			var info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('dailyMotionInput')[0]);
		info.formData._data['dailyMotionInput'] = ['v='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});