/*
	Copyright (c) 2006-2010, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.flash $Revision: 1.24.2.2 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.flash');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.lang.hash');
dojo.require('epages.io.json');

epages.cartridges.de_epages.externalcontent.Flash = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Flash,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.Flash',
	preview         : '',  // path to the MBO preview images, e.g.: epages.vars.StoreRoot + '/BO/icons/content_ico_m_navelementgroup_flash.gif
	title           : 'flash',
	interpreter     : epages.vars.StoreRoot + '/Flash/interpreter.swf',
	xmlfile         : null,
	previewWidth    : 400,
	wMode           : 'Window', // transparent, Window
	guid            : null, // remember guid to generate same xml file
	form            : undefined,
	formData        : {
		bgColor : ['#ffffff']
	},

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			interpreter : this.interpreter,
			xmlfile     : this.xmlfile,
			wMode       : this.wMode,
			guid        : this.guid
		});
		return info;
	},

	contentString: function (info, ispreview) {
		if (ispreview === undefined) {
			ispreview = false;
		}
		var height = info.height;
		var bgColor = info.formData.get('bgColor') != undefined ? info.formData.get('bgColor')[0] : '#ffffff';
		var wMode = bgColor == 'transparent' ? 'transparent' : info.wMode;
		var width = info.width;
		var mini = '';
		if(ispreview){
			height = Math.round(this.previewWidth * info.height / info.width);
			width = this.previewWidth;
			wMode = bgColor == 'transparent' ? 'transparent' : 'opaque';
			mini = '&var_mini=1';
		}
		return [ '<object type="application/x-shockwave-flash',
			'wmode="' + wMode,
			'bgColor="' + bgColor,
			'data="' + info.interpreter + '?var_src='+ info.xmlfile + '&ie=bug' + (ispreview ? '&var_mini=1': ''),
			'width="' + width,
			'height="' + height,
			'allowScriptAccess="always',
			'><param name="movie" value="'+ info.interpreter + '?var_src='+ info.xmlfile + '&ie=bug' + mini,
			'></param><param name="wmode" value="' + wMode,
			'></param><param name="bgColor" value="' + bgColor,
			'></param><param name="allowScriptAccess" value="always',
			'></param><embed type="application/x-shockwave-flash"',
			' wmode="'+wMode+'" bgColor="'+bgColor+'" allowScriptAccess="always"',
			' src="' + info.interpreter + '?var_src='+ info.xmlfile +'&ie=bug' + mini+'"',
			' /></object>'
		].join('" ');
	},

	saveForm: function () {
		epages.cartridges.de_epages.design.MceContent.prototype.saveForm.apply(this, arguments);
		var urlAction = this.form.action;
		var me = this;
		var json = new epages.io.Json();
		var params = dojo.formToObject(this.form);
		if (this.guid !== null) {
			params['GUID'] = this.guid;
		}
		var output = json.loadSync(urlAction, params);
		dojo.mixin(me,output.data);
		return;
	}

});

