/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.flickr $Revision: 1.19.2.4 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.flickr');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.io.text');

epages.cartridges.de_epages.externalcontent.Flickr = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Flickr,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass         : 'epages.cartridges.de_epages.externalcontent.Flickr',
	title                : 'Flickr',
	width                : 113,
	height               : 151,
	userid               : '',
	username             : '',
	selection            : '',
	bgColor              : '',
	txtColor             : '',
	linkColor            : '',
	tag                  : '',
	doInsertDom          : false,
	directPreview        : false,
	imagelink            : '',
	imageid              : '',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_flickr.png',

	flickrphotoslink     : 'http://www.flickr.com/photos',
	flickrslideshowlink  : 'http://www.flickr.com/slideShow/index.gne',
	fototitle            : 'Photo Sharing with Flickr',
	errormessageimage    : '! could not load image !',
	widthslideshow       : 500,
	heightslideshow      : 500,

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			userid               : this.userid,
			username             : this.username,
			selection            : this.selection,
			bgColor              : this.bgColor,
			txtColor             : this.txtColor,
			linkColor            : this.linkColor,
			tag                  : this.tag,
			imagelink            : this.imagelink,
			imageid              : this.imageid
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		var selectionValue = '';
		for( var i=0,iLength=this.formData.get('flickrSelection').length ; i<iLength ; i++ ){
			if(this.formData.get('flickrSelection')[i] != ''){
				selectionValue = this.formData.get('flickrSelection')[i];
			}
		}
    if(selectionValue === 'Slideshow'){
    	this.height = this.heightslideshow;
    	this.width = this.heightslideshow;
    	this.doInsertDom = false;
    }
    else if(selectionValue === 'OwnImage'){
    	var regexpsize = /\/[^\/]+_([a-z]).jpg$/;
			var sizecharacter = regexpsize.exec(this.formData.get('flickrImageLink')[0]);
			if(sizecharacter){
				switch (sizecharacter[1]) {
					case 's':
						this.height= 75;
						break;
					case 't':
						this.height= 100;
						break;
					case 'm':
						this.height= 240;
						break;
					case 'o':
						this.height= '100%';
						break;
					default:
						this.height = 200;
						break;
				}
			}
			else{
				this.height = 500;
			}
			this.width = this.height;
			this.doInsertDom = true;
    }
    else{
    	this.doInsertDom = false;
    	this.width = 113;
    	this.height = 151;
    }
  },
	contentString: function (info, ispreview) {
		var finalstring = '';
		if(info.formData.get('flickrSelection').length > 0){
			var radiovalues = info.formData.get('flickrSelection');
			for( var i=0,l=radiovalues.length ; i<l ; i++ ){
				if(radiovalues[i] != undefined && radiovalues[i] != ''){
					info.selection = radiovalues[i];
				}
			}
			info.userid = info.formData.get('flickrUserId')[0] != undefined ?  info.formData.get('flickrUserId')[0] : '';
			info.username = info.formData.get('flickrUserName')[0] != undefined ? info.formData.get('flickrUserName')[0] : '';
			info.bgColor = info.formData.get('flickrBgColor')[0] != undefined ? info.formData.get('flickrBgColor')[0] : '';
			info.txtColor = info.formData.get('flickrTxtColor')[0] != undefined ? info.formData.get('flickrTxtColor')[0] : '';
			info.linkColor = info.formData.get('flickrLinkColor')[0] != undefined ? info.formData.get('flickrLinkColor')[0] :'';
			info.tag = info.formData.get('flickrTag')[0] != undefined ? info.formData.get('flickrTag')[0] : '';
			info.imagelink = info.formData.get('flickrImageLink')[0] != undefined ? info.formData.get('flickrImageLink')[0] : '';
			if(info.selection == 'Badge'){
				var textIo = new epages.io.Text();
				finalstring = textIo.load(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent','flickrbadgetemplate.html'));
				finalstring = finalstring.replace(/{userid}/g,info.userid);
				finalstring = finalstring.replace(/{username}/g,info.username);
				finalstring = finalstring.replace(/{bgColor}/g,info.bgColor);
				finalstring = finalstring.replace(/{txtColor}/g,info.txtColor);
				finalstring = finalstring.replace(/{linkColor}/g,info.linkColor);
				finalstring = finalstring.replace(/{tag}/g,info.tag);
			}
			if(info.selection == 'OwnImage'){
				var regexpid = /\/([0-9]+)_[^\/]+$/;
				var regexpresult = regexpid.exec(info.imagelink);
				info.imageid = regexpresult[1];

				if(info.imageid==""){
					alert(this.errormessageimage);
					return "";
				}
				finalstring = [
				'<a href="'+this.flickrphotoslink+'/'+info.userid+'/'+info.imageid+'/" title="'+this.fototitle+'" target=_blank"><img src="'+info.imagelink+'" alt="'+this.fototitle+'" /></a>'
				].join('\n');
			}
			if(info.selection == 'Slideshow'){
				info.tag = escape(info.tag);
				finalstring = [
				'<iframe align="center" src="'+this.flickrslideshowlink+'?user_id='+info.userid+'&tags='+info.tag+'" frameBorder="0" width="500" scrolling="no" height="500"></iframe>'
				].join('\n');
			}
		}
		return finalstring;
	},
	loadPreview: function (domObject) {
		if(this.formData.get('flickrSelection') && this.formData.get('flickrSelection').length > 0){
			var radioSelection = '';
			var radiovalues = this.formData.get('flickrSelection');
			for( var i=0,l=radiovalues.length ; i<l ; i++ ){
				if(radiovalues[i] != undefined && radiovalues[i] != ''){
					radioSelection = radiovalues[i];
				}
			}
			if(radioSelection == "Badge"){
				var iframe = this.getIframeDocument(domObject);
				var body = iframe.getElementsByTagName('body').item(0);
				var userid = this.formData.get('flickrUserId')[0] != undefined ? this.formData.get('flickrUserId')[0] : '';
				var bgColor = this.formData.get('flickrBgColor')[0] != undefined ? this.formData.get('flickrBgColor')[0] : '';
				if(bgColor != ''){
					bgColor = bgColor.substring(1);
				}
				var txtColor = this.formData.get('flickrTxtColor')[0] != undefined ? this.formData.get('flickrTxtColor')[0] : '';
				var linkColor = this.formData.get('flickrLinkColor')[0] != undefined ? this.formData.get('flickrLinkColor')[0] : '';
				var tag = this.formData.get('flickrTag')[0] != undefined ? this.formData.get('flickrTag')[0] : '';
				body.innerHTML = [
				'<style type="text/css">',
				'.zg_div {margin:0px 5px 5px 0px; width:117px;}',
				'.zg_div_inner {border: solid 1px #000000; background-color:'+bgColor+';  color:'+txtColor+'; text-align:center; font-family:arial, helvetica; font-size:11px;}',
				'.zg_div a, .zg_div a:hover, .zg_div a:visited {color:'+linkColor+'; background:inherit !important; text-decoration:none !important;}',
				'</style>',
				'<div class="zg_div"><div class="zg_div_inner"><a href="http://www.flickr.com">www.<strong style="color:#3993ff">flick<span style="color:#ff1c92">r</span></strong>.com</a><br>',
				'<iframe style="background-color:#'+bgColor+'; border-color:#'+bgColor+'; border:none;" width="113" height="151" frameborder="0" scrolling="no" src="http://www.flickr.com/apps/badge/badge_iframe.gne?zg_bg_color='+bgColor+'&zg_person_id='+userid+'&zg_tags='+tag+'&zg_tag_mode=any" title="Flickr Badge"><\/iframe>',
				'<div id="zg_whatlink"><a href="http://www.flickr.com/badge.gne" target="_blank"	style="color:'+linkColor+'">What is this?<\/a><\/div>',
				'</div>',
				'</div>'
				].join("\n");
			}
			else{
				if(this.getIframeDocument(domObject) && this.getIframeDocument(domObject).getElementsByTagName('body').length > 0){
					this.getIframeDocument(domObject).getElementsByTagName('body')[0].innerHTML = this.contentString(this.info(), true);
				}
			}
		}
		else{
			return '';
		}
	}
});