/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.lastfm $Revision: 1.13.2.1 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.lastfm');
dojo.require('epages.cartridges.de_epages.design.mcecontent');

epages.cartridges.de_epages.externalcontent.LastFm = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.LastFm,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass       : 'epages.cartridges.de_epages.externalcontent.LastFm',
	title              : 'lastFM',
	width              : 340,
	height             : 123,
	selection          : '',
	searchstring       : '',
	numberofentrys     : 5, //number of entrys in generated images
	linkuser           : 'http://www.lastfm.de/user/', //link of the usersdata
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_lastfm.png',
	directPreview      : false,

	chartstyle         : 'lastfmplain',
	linkimagegen       : 'http://imagegen.last.fm/lastfmplain/', //link to the generated images
	linkplayer         : 'http://cdn.last.fm/widgets/radio/22.swf', //link to the lastfmplayer
	playertext         : 'Button zum starten', //Text inside the player bar after it is loaded

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			selection          : this.selection,
			searchstring       : this.searchstring,
			numberofentrys     : this.numberofentrys
		});
		return info;
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('LastFmRadio') && info.formData.get('LastFmRadio').length > 0){
			var radiovalues = info.formData.get('LastFmRadio');
			for( var i=0,l=radiovalues.length ; i<l ; i++ ){
				if(radiovalues[i] != undefined && radiovalues[i] != ''){
					info.selection = radiovalues[i];
				}
			};
			info.searchstring = info.formData.get('LastFmInput')[0];
			info.numberofentrys = info.formData.get('LastFmNumberOfEntrys')[0];
		}
		var finalstring ="";
		var searchmodelinkstring1 = "";
		var searchmodelinkstring2 = "";
		var selectiontype = "";
		switch(info.selection){
			case 'similarartists':
				searchmodelinkstring1 = 'artist';
				searchmodelinkstring2 = 'similarartists';
				selectiontype = 'radio';
				break;
			case 'tag':
				searchmodelinkstring1 = 'globaltags';
				searchmodelinkstring2 = 'globaltags';
				selectiontype = 'radio';
				break;
			case 'user':
				searchmodelinkstring1 = 'user';
				searchmodelinkstring2 = 'personal';
				selectiontype = 'radio';
				break;
			case 'neighbour':
				searchmodelinkstring1 = 'user';
				searchmodelinkstring2 = 'neighbours';
				selectiontype = 'radio';
				break;
			case 'recentlyplayedtracks':
				searchmodelinkstring1 = 'recenttracks';
				selectiontype = 'charts';
				break;
			case 'tracksweek':
				searchmodelinkstring1 = 'tracks';
				selectiontype = 'charts';
				break;
			case 'artistsweek':
				searchmodelinkstring1 = 'artists';
				selectiontype = 'charts';
				break;
			case 'tracksuser':
				searchmodelinkstring1 = 'otracks';
				selectiontype = 'charts';
				break;
			case 'artistsuser':
				searchmodelinkstring1 = 'oartists';
				selectiontype = 'charts';
				break;
		}
		switch(selectiontype){
			case 'charts':
				finalstring = '<a href="'+this.linkuser+''+info.searchstring+'/?chartstyle='+this.chartstyle+'"><img src="'+this.linkimagegen+''+searchmodelinkstring1+'/'+info.numberofentrys+'/'+info.searchstring+'.gif" border="0" /></a>';
				break;
			case 'radio':
				finalstring = ['<style type="text/css">table.lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/de/header/radio/regular_grey.png) no-repeat 0 0 !important;}table.lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb tr.lfmEmbed object {float:left;}table.lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/de/footer/grey_np.png) no-repeat 0px 0 !important;;}table.lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/de/footer/grey_np.png) no-repeat -85px 0 !important;}table.lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/de/footer/grey_np.png) no-repeat -159px 0 !important;}</style>',
				'<table class="lfmWidgetradio_3617b50c10e1ead1a0e79bd928700afb" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="Pop Radio" href="http://www.lastfm.de/listen/'+searchmodelinkstring1+'/'+info.searchstring+'" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/de/header/radio/regular_grey.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td>',
				'<object type="application/x-shockwave-flash" data="'+this.linkplayer+'" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_1274454592" width="184" height="140"> <param name="movie" value="'+this.linkplayer+'" /> <param name="flashvars" value="lfmMode=radio&amp;radioURL='+searchmodelinkstring1+'%2F'+info.searchstring+'&amp;title='+info.searchstring+'+Radio&amp;theme=grey&amp;lang=de&amp;widget_id=radio_3617b50c10e1ead1a0e79bd928700afb" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="999999" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object>',
				'</td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/grey.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.lastfm.de/widgets/?url='+searchmodelinkstring2+'%2F'+info.searchstring+'&amp;colour=grey&amp;size=regular&amp;autostart=0&amp;from=code&amp;widget=radio" title="Hol dir dein eigenes Widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/de/footer/grey_np.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.lastfm.de/" title="zu Last.fm" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/de/footer/grey_np.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.lastfm.de/widgets/popup/?url='+searchmodelinkstring1+'%2F'+info.searchstring+'&amp;colour=grey&amp;size=regular&amp;autostart=0&amp;from=code&amp;widget=radio&amp;resize=1" title="Lade dieses Widget in einem Popup" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/de/footer/grey_np.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + \'&amp;resize=0\',\'lfm_popup\',\'height=240,width=234,resizable=yes,scrollbars=yes\'); return false;"></a></td></tr></table></td></tr></table>'
				].join('');
				break;
		}
		return finalstring;
	}
});
