/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.msnvideo');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.MsnVideo = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.MsnVideo,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.MsnVideo',
	title           : 'MsnVideo',
	msnVideoInput      : '',
	width           : 470,
	height          : 406,
	size            : 'large',
	embededlink     : 'http://images.video.msn.com/flash/soapbox1_1.swf',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_msnvideo.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			msnVideoInput         : this.msnVideoInput,
			size              : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}

	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /vid=([\w-]+)/; //RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /v=([\w-]+)/; //RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('msnVideoInput')){
			info.msnVideoInput = info.formData.get('msnVideoInput')[0];
			var videoid = this._getVideoId(info.msnVideoInput);

			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('msnVideoError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('msnVideoInput').length != 0){
					document.getElementsByName('msnVideoInput')[0].value = 'v='+videoid;
				}
				info.formData._data['msnVideoInput'] = ['v='+videoid];

				var finalembed = '<embed src="'+this.embededlink+'" width="'+info.width+'" height="'+info.height+'" id="iqor6t1u" type="application/x-shockwave-flash" allowFullScreen="true" allowScriptAccess="always" pluginspage="http://macromedia.com/go/getflashplayer" flashvars="c=v&v='+videoid+'&ifs=true&fr=msnvideo"></embed>';


				return finalembed;
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('msnVideoInput')[0]);
		info.formData._data['msnVideoInput'] = ['v='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});