/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.myvideo');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.MyVideo = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.MyVideo,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.MyVideo',
	title           : 'MyVideo',
	myVideoInput    : '',
	width           : 470,
	height          : 406,
	size            : 'large',
	embededlink     : 'http://www.myvideo.de/movie/',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_myvideo.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			myVideoInput  : this.myVideoInput,
			size          : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 470;
			this.height = 406;
		}
		else if(this.formData.get('videosize')[0] == "medium"){
			this.width = 425;
			this.height = 367;
		}
		else{
			this.width = 200;
			this.height = 173;
		}
	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /movie\/([\w-]+)/;//RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /watch\/([\w-]+)/; //RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid == null || videoid == ''){
			var RegExp2 = /movie=([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid != "" && videoid != null){
			return videoid[1];
		}else{
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('myVideoInput')){
			info.myVideoInput = info.formData.get('myVideoInput')[0];
			var videoid = this._getVideoId(info.myVideoInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('myVideoError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('myVideoInput').length != 0){
					document.getElementsByName('myVideoInput')[0].value = 'movie='+videoid;
				}
				info.formData._data['myVideoInput'] = ['movie='+videoid];
				//return '<object width="'+info.width+'" height="'+info.height+' data="'+this.embededlink+videoid+'"><param name="movie" value="'+this.embededlink+videoid+'"></param><embed src="'+this	.embededlink+videoid+'"  width="'+info.width+'" height="'+info.height+'"></embed></object>';
  			return '<object style="width:'+info.width+'px; height:'+info.height+'px;" width="info.width" height="info.width" type="application/x-shockwave-flash" data="'+this.embededlink+videoid+'"><param name="movie" value="'+this.embededlink+videoid+'"></param><param name="AllowFullscreen" value="true"></param><param name="AllowScriptAccess" value="always"></param><embed src="'+this.embededlink+videoid+'" width="'+info.width+'" height="'+info.height+'"></embed></object>';
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			var info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('myVideoInput')[0]);
		info.formData._data['myVideoInput'] = ['movie='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});