dojo.provide('epages.cartridges.de_epages.externalcontent.sevenload');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.Sevenload = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Sevenload,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.Sevenload',
	title           : 'Sevenload',
	sevenloadInput	: '',
	width           : 470,
	height          : 406,
	autostart				: '',
	size            : 'large',
	embededlink     : 'http://de.sevenload.com/pl/',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_sevenload.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			sevenloadInput 		: this.sevenloadInput,
			size          		: this.size
		});
		return info;
	},

	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}
		if(this.formData.get('autostart')[0]){
			this.autostart = ',play';
		}else{
			this.autostart = '';
		}
	},

	_getVideoId:function(input){
		// summary : RegExpS to find videoid
		var videoid = '';
		var RegExp1 = /pl\/([a-zA-z0-9]+)/;
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /folgen\/([a-zA-z0-9]+)/;
			videoid = RegExp2.exec(input);
			if(videoid == null || videoid == ''){
				var RegExp3 = /videos\/([a-zA-z0-9]+)/;
				videoid = RegExp2.exec(input);
			}
		}
		if(videoid != "" && videoid != null){
			return videoid[1];
		}else{
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('sevenloadInput')){
			info.sevenloadInput = info.formData.get('sevenloadInput')[0];
			var videoid = this._getVideoId(info.sevenloadInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('sevenloadError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('sevenloadInput').length != 0){
					document.getElementsByName('sevenloadInput')[0].value = 'pl/'+videoid;
				}
				info.formData._data['sevenloadInput'] = ['pl/'+videoid];
  			var finalLink = this.embededlink+videoid+'/'+info.width+'x'+info.height+'/swf'+info.autostart;
  			return '<object type="application/x-shockwave-flash" data="'+finalLink+'" width="'+info.width+'" height="'+info.height+'"><param name="allowFullscreen" value="true" /><param name="allowScriptAccess" value="always" /><param name="movie" value="'+finalLink+'" /></object>';
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('sevenloadInput')[0]);
		info.formData._data['sevenloadInput'] = ['pl/'+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});