/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.veoh');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.Veoh = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Veoh,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.Veoh',
	title           : 'Veoh',
	veohInput				: '',
	width           : 470,
	height          : 406,
	autostart				: '0',
	size            : 'large',
	embededlink     : 'http://www.veoh.com/static/swf/webplayer/WebPlayer.swf?version=AFrontend.5.4.2.6.1001&player=videodetailsembedded&id=anonymous',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_veoh.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			veohInput 				: this.veohInput,
			size          		: this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}
		if(this.formData.get('autostart')[0]){
			this.autostart = '1';
		}else{
			this.autostart = '0';
		}
	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /permalinkId=([\w-]+)/;//RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /watch\/([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid == null || videoid == ''){
			var RegExp2 = /v=([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('veohInput')){
			info.veohInput = info.formData.get('veohInput')[0];
			var videoid = this._getVideoId(info.veohInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('veohError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('veohInput').length != 0){
					document.getElementsByName('veohInput')[0].value = 'v='+videoid;
				}
				info.formData._data['veohInput'] = ['v='+videoid];
  			var finalLink = this.embededlink+'&permalinkId='+videoid+'&videoAutoPlay='+info.autostart;
  			//return '<object type="application/x-shockwave-flash" data="'+finalLink+'" width="'+info.width+'" height="'+info.height+'"><param name="allowFullscreen" value="true" /><param name="allowScriptAccess" value="always" /><param name="movie" value="'+finalLink+'" /></object>';
  			return '<object width="'+info.width+'" height="'+info.height+'" id="veohFlashPlayer" name="veohFlashPlayer"><param name="movie" value="'+finalLink+'"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="'+finalLink+'" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'+info.width+'" height="'+info.height+'" id="veohFlashPlayerEmbed" name="veohFlashPlayerEmbed"></embed></object>';
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('veohInput')[0]);
		info.formData._data['veohInput'] = ['v='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});