/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.vimeo');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.Vimeo = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Vimeo,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.Vimeo',
	title           : 'Vimeo',
	vimeoInput      : '',
	width           : 470,
	height          : 406,
	size            : 'large',
	embededlink     : 'http://vimeo.com/moogaloop.swf?server=vimeo.com&amp;show_portrait=0&amp;color=00ADEF&amp;fullscreen=1',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_vimeo.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			vimeoInput         : this.vimeoInput,
			size              : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}

	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /clip_id=([\w-]+)/;//RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /vimeo.com\/([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid == null || videoid == ''){
			var RegExp3 = /v=([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp3.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('vimeoInput')){
			info.vimeoInput = info.formData.get('vimeoInput')[0];
			var videoid = this._getVideoId(info.vimeoInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('vimeoError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('vimeoInput').length != 0){
					document.getElementsByName('vimeoInput')[0].value = 'v='+videoid;
				}
				info.formData._data['vimeoInput'] = ['v='+videoid];

				var finalLink = this.embededlink+'&amp;clip_id='+videoid;
				var finalembed = '<object width="'+info.width+'" height="'+info.height+'"><param name="allowfullscreen" value="true" /><param name="allowscriptaccess" value="always" /><param name="movie" value="'+finalLink+'" /><embed src="'+finalLink+'" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" width="'+info.width+'" height="'+info.height+'"></embed></object>';
				return finalembed;
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('vimeoInput')[0]);
		info.formData._data['vimeoInput'] = ['v='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});