/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.wideo');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.Wideo = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Wideo,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.Wideo',
	title           : 'Wideo',
	wideoInput   		: '',
	width           : 470,
	height          : 406,
	autostart				: 'false',
	size            : 'large',
	embededlink     : 'http://sa.kewego.com/swf/p3/epix.swf',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_wideo.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			wideoInput     : this.wideoInput,
			size           : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}
		if(this.formData.get('autostart')[0]){
			this.autostart = 'true';
		}else{
			this.autostart = 'false';
		}
	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /video\/([\w-]+)/; //RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /id=\"([\w-]+)/; //RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid == null || videoid == ''){
			var RegExp3 = /v=([\w-]+)/; //RegExp to find videoid in URL
			videoid = RegExp3.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('wideoInput')){
			info.wideoInput = info.formData.get('wideoInput')[0];
			var videoid = this._getVideoId(info.wideoInput);

			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('wideoError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('wideoInput').length != 0){
					document.getElementsByName('wideoInput')[0].value = 'v='+videoid;
				}
				info.formData._data['wideoInput'] = ['v='+videoid];

				var finalembed = '<object name="'+videoid+'" id="'+videoid+'" type="application/x-shockwave-flash" data="'+this.embededlink+'" width="'+info.width+'" height="'+info.height+'"><param name="flashVars" value="language_code=fr&playerKey=0df9b773a15b&skinKey=7109c4112f57&sig='+videoid+'&autostart='+info.autostart+'&advertise=1" /><param name="movie" value="'+this.embededlink+'" /><param name="allowFullScreen" value="true" /><param name="allowscriptaccess" value="always" /></object>';
				return finalembed;
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('wideoInput')[0]);
		info.formData._data['wideoInput'] = ['v='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});