/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.youtube $Revision: 1.12.2.1 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.youtube');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.YouTube = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.YouTube,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.YouTube',
	title           : 'YouTube',
	youTubeInput    : '',
	width           : 425,
	height          : 350,
	size            : 'large',
	embededlink     : 'http://www.youtube.com/v/',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_youtube.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			youTubeInput  : this.youTubeInput,
			size          : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		if(this.formData.get('videosize')[0] == "large"){
			this.width = 425;
			this.height = 350;
		}
		else{
			this.width = 300;
			this.height = 250;
		}
	},
	_getVideoId:function(input){
		var videoid = '';
		var RegExp1 = /v\/([\w-]+)/;//RegExp to find videoid in embed
		videoid = RegExp1.exec(input);
		if(videoid == null || videoid == ''){
			var RegExp2 = /v=([\w-]+)/;//RegExp to find videoid in URL
			videoid = RegExp2.exec(input);
		}
		if(videoid != "" && videoid != null){ 
			return videoid[1];
		}else{ 
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('youTubeInput')){
			info.youTubeInput = info.formData.get('youTubeInput')[0];
			var videoid = this._getVideoId(info.youTubeInput);
			if(videoid === false){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('YouTubeError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				if(document.getElementsByName('youTubeInput').length != 0){ 
					document.getElementsByName('youTubeInput')[0].value = 'v='+videoid;
				}
				info.formData._data['youTubeInput'] = ['v='+videoid];
				return '<object width="'+info.width+'" height="'+info.height+'"><param name="movie" value="'+this.embededlink+videoid+'"></param><param name="wmode" value="transparent"></param><embed src="'+this	.embededlink+videoid+'" type="application/x-shockwave-flash" wmode="transparent" width="'+info.width+'" height="'+info.height+'"></embed></object>';
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){ 
			var info = this.info();
		}
		var videoid = this._getVideoId(info.formData.get('youTubeInput')[0]);
		info.formData._data['youTubeInput'] = ['v='+videoid];
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});