IF OBJECT_ID('i_GoogleAdWordsCode') IS NOT NULL
    DROP PROCEDURE i_GoogleAdWordsCode
GO
CREATE PROCEDURE i_GoogleAdWordsCode (
    @GoogleAdWordsCodeID  int          = null
,   @CouponCode           varchar(32)  
,   @ShopID               int          = null
,   @IsUsed               tinyint      
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_googleadwordscode
    ELSE                     BEGIN TRANSACTION ti_googleadwordscode

        IF @GoogleAdWordsCodeID IS NULL SELECT @GoogleAdWordsCodeID = 1 + max(googleadwordscodeid) FROM googleadwordscode HOLDLOCK
        IF @GoogleAdWordsCodeID IS NULL SELECT @GoogleAdWordsCodeID = 1

        INSERT INTO googleadwordscode
               ( googleadwordscodeid, couponcode, shopid, isused)
        SELECT  @GoogleAdWordsCodeID,@CouponCode,@ShopID,@IsUsed

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_googleadwordscode
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_googleadwordscode
    RETURN 0
END
GO
