/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.Mimetypehtml $Revision: 1.2.6.1 $

*/

dojo.provide("epages.cartridges.de_epages.mediagallery.Mimetypehtml");
dojo.require("epages.cartridges.de_epages.mediagallery.widget.Mediagallery");

epages.vars.mimetypeHtmlMap = {
	mimetypes:	{
		'application/x-shockwave-flash' : {
																				classid : 'D27CDB6E-AE6D-11cf-96B8-444553540000',
																				codebase: 'https://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0',
																				template: 'embed',
																				editorclass: 'mceItemFlash'
																			},
		'application/x-director' 				: {
																				classid : '166B1BCA-3F9C-11CF-8075-444553540000',
																				codebase: 'https://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0',
																				template: 'embed',
																				editorclass: 'mceItemShockWave'
																			},
		'video/quicktime' 							: {
																				classid : '02BF25D5-8C17-4B23-BC80-D3488ABDDC6B',
																				codebase: 'https://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0',
																				template: 'embed',
																				editorclass: 'mceItemQuickTime'
																			},
		'audio/x-pn-realaudio-plugin'		: {
																				classid : 'CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA',
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',	// ?? media player
																				template: 'embed',
																				editorclass: 'mceItemRealMedia'
																			},
		'application/vnd.rn-realmedia'	: {
																				classid : 'CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA',
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',	// ?? media player
																				template: 'embed',
																				editorclass: 'mceItemRealMedia'
																			},
		'application/x-mplayer2'				: {
																				classid : '6BF52A52-394A-11D3-B153-00C04F79FAA6', 																									  // (media_wmp6_compatible') ? '05589FA1-C356-11CE-BF01-00AA0055595A' : '6BF52A52-394A-11D3-B153-00C04F79FAA6';
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
																				template: 'embed',
																				editorclass: 'mceItemWindowsMedia'
																			},
		'video/x-msvideo'								: {
																				classid : '6BF52A52-394A-11D3-B153-00C04F79FAA6', 																									  // (media_wmp6_compatible') ? '05589FA1-C356-11CE-BF01-00AA0055595A' : '6BF52A52-394A-11D3-B153-00C04F79FAA6';
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
																				template: 'embed',
																				editorclass: 'mceItemWindowsMedia'
																			},
		'audio/x-ms-wmv'								: {
																				classid : '6BF52A52-394A-11D3-B153-00C04F79FAA6', 																									  // (media_wmp6_compatible') ? '05589FA1-C356-11CE-BF01-00AA0055595A' : '6BF52A52-394A-11D3-B153-00C04F79FAA6';
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
																				template: 'embed',
																				editorclass: 'mceItemWindowsMedia'
																			}
	},

	templates: {
		image: function(mimetype, mimetypemap, params) {
			return '<img mce_src="'+params.src+ '" src="'+params.src+ '" alt="'+params.name+'" style="border: 0px" />';
		},

		link: function(mimetype, mimetypemap, params) {
			return '<a href="'+params.src+ '" target="_blank" >'+params.name+'</a>';
		},

		embed: function(mimetype, mimetypemap, params, insertIntoEditor) {
			if(!insertIntoEditor) {
				var classid = mimetypemap.classid;
				var codebase = mimetypemap.codebase;
				var html = '';

				html += '<object classid="clsid:' + classid + '" codebase="' + codebase + '"';
				html += params.id !== undefined ? ' id="' + params.id + '"' : '';
				html += params.name !== undefined ? ' name="' + params.name + '"' : '';
				html += params.width !== undefined ? ' width="' + params.width + '"' : '';
				html += params.height !== undefined ? ' height="' + params.height + '"' : '';
				html += params.align !== undefined ? ' align="' + params.align + '"' : '';
				html += '>';

				for (var n in params){
					html += '<param name="' + n + '" value="' + params[n] + '">';
				}

				html += '<embed type="' + mimetype + '"';

				for (var n in params){
					html += n + '="' + params[n] + '" ';
				}

				html += '></embed></object>';

				return html;
			} else {
				var html="";
				html += '<img class="'+mimetypemap.editorclass+'" src="'+epages.vars.StoreRoot+'/javascript/tiny_mce/themes/inline/images/spacer.gif" border="0"';
				html += params.width !== undefined ? ' width="' + params.width + '"' : ' width="200"';
				html += params.height !== undefined ? ' height="' + params.height + '"' : ' height="100"';

				html += ' style="';
				html += params.width  !== undefined ? ' width:'  + params.width  + 'px ;' : ' width: 200px;';
				html += params.height !== undefined ? ' height:' + params.height + 'px; ' : ' height: 100px;';

				html += '" title="';
				var i=0
				for (var n in params) {
					if(i!=0){
						html +=',';
					}
					html += n + ":'" + params[n]+"'";
					i++;
				}
				html += '" />';
				return html;
			}
		}
	}
};

getHtmlByMimeType = function(/* string */mimetype,/* array? */params, /* boolean? */insertIntoEditor) {
	var html="";

	if(mimetype==null){
		mimetype="";
	}
	// adjust url param for windows media player
	if(mimetype=="application/x-mplayer2" || mimetype=="video/x-msvideo" || mimetype=="audio/x-ms-wmv"){
		params.url = params.src;
	}
	var mimetypeVar=epages.vars.mimetypeHtmlMap.mimetypes[mimetype];

	if(mimetype.match(/^image/)){
		html=epages.vars.mimetypeHtmlMap.templates['image'](mimetype, mimetypeVar, params);
	}else if(mimetypeVar !== undefined){
		html= epages.vars.mimetypeHtmlMap.templates[mimetypeVar.template](mimetype, mimetypeVar, params, insertIntoEditor);
	}else{
		html= epages.vars.mimetypeHtmlMap.templates['link'](mimetype, mimetypeVar, params);
	}
	return html;
};