-- #201
CREATE TABLE object (
    objectid             int           not null
,   classid              int           not null
,   parentid             int           null
,   alias                varchar(255)  not null
,   position             int           not null
,   guid                 varchar(36)   not null
,   inherit              bit           not null
,   creationdate         datetime      not null
,   siteid               int           not null
,   filepathpart         varchar(255)  null

,   constraint pk_object                        primary key (objectid)
,   constraint fk_object_object                 foreign key (parentid)
        references object                           (objectid)
,   constraint ck_object_parent                 check (objectid <> parentid)
) LOCK DATAROWS
GO
CREATE INDEX i_object_class ON object (classid)
GO
CREATE UNIQUE INDEX u_object_alias ON object (parentid, alias)
GO
CREATE UNIQUE INDEX u_object_guid ON object (guid)
GO
CREATE INDEX i_object_siteid_classid_alias ON object (siteid, classid, alias)
GO
