/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Sidebarcontroller $Revision: 1.12.8.2 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Sidebarcontroller");
dojo.require("epages.lang.hash");
dojo.require("epages.widget");
dojo.require('dijit._Container');

dojo.declare("epages.cartridges.de_epages.presentation.widget.Sidebarcontroller",
	[dijit._Widget, dijit._Container],
	{
		contentPane             : "",
		_contentScrollBarHandler: undefined,
		_sideBarPaddings				: undefined,

		startup:	function() {
			this.inherited("startup", arguments);
			// get contentPane DomeNode
			if(this.contentPane!= ""){ 
				this.contentPane=$(this.contentPane);
			}

			this._sideBarPaddings = new epages.lang.Hash();

			// register sidebars
			var children = this.getChildren();

			for(var	i=0,l=children.length; i<l; i++)	{
				if(children[i].declaredClass=="epages.cartridges.de_epages.presentation.widget.Sidebar") {
						dojo.subscribe(children[i].id + '/afterShowSidebar',	this, '_setPadding');
						dojo.subscribe(children[i].id + '/afterShowSidebar',	this, '_resizeMinHeight');
						dojo.subscribe(children[i].id + '/afterHideSidebar',	this, '_setPadding');
						dojo.subscribe(children[i].id + '/afterSetWidth', 		this, '_setPadding');
						if(children[i].isVisible){ 
							children[i].show(children[i].isOverlay,true);
						}
				}
			}
			dojo.subscribe('Sidebar/changeHeight', this, '_checkHeight' );
			dojo.subscribe('contentPane/resize',   this, '_resizeHeight');

			dojo.subscribe('Sidebar/changeHeight', this, '_resizeMinHeight');
			this._resizeMinHeight(); // sadly this is needed for Fx3 and IE
		},

		enableScrollMode: function(/*Object*/ options){
			options['topicname']="contentPane";
			// add scrollbar handler
			if(this._contentScrollBarHandler === undefined) {
				this._contentScrollBarHandler = new epages.event.AdjustOnResize(this.contentPane, options);
				this.domNode.style.minHeight = "";
			} else {
				this._contentScrollBarHandler.setOptions(options);
			}

			// remove document scrollbar
			// document.getElementsByTagName("html")[0].style.overflow="hidden";
		},

		_setPadding: function(/*Widget*/ options)  {
			this._sideBarPaddings.set(options.side, options.width);

			// set mainlayout padding
			if(options.side.toLowerCase()=="left" && isNaN(options.width)==false) {
				this.domNode.style.paddingLeft=options.width+"px";
			}
			if(options.side.toLowerCase()=="right" && isNaN(options.width)==false) {
				this.domNode.style.paddingRight=options.width+"px";
			}
			// if scroll mode is enabled -> change values of scrollbar handler
			if(this._contentScrollBarHandler !== undefined) {
				var deltaWindowWidth=0;
				this._sideBarPaddings.each(function(pair){
					deltaWindowWidth+=pair.value;
				});

				var pageWidthSpace = (epages.vars.Layout.pageWidthSpace) ? epages.vars.Layout.pageWidthSpace : 0;

				this._contentScrollBarHandler.setOptions({
					deltaWindowWidth: deltaWindowWidth + pageWidthSpace
				});
			}
		},

		_resizeHeight: function(width, height) {
			this.domNode.style.height=height+"px";
		},

		_resizeMinHeight: function() {
			var scNode = $("SidebarContent");
			if(scNode) {
				scNode.parentNode.style.visibility = "hidden";
			} else {
				console.warn('SidebarContent node not found in '+this.declaredClass);
			}
			// minimize jitter of .PropertyContainer on recalc
			if($("EmbeddedStorefront")) {
				this.domNode.style.minHeight = "0";
			}else {
				this.domNode.style.minHeight = (($("RightSidebarTabs") || dojo.body()).offsetHeight + ($("TrialShopBox") ? $("TrialShopBox").offsetHeight : 0)) + "px";
			}
			setTimeout(function() {
				var scNode = $("SidebarContent");
				if(scNode) {
					scNode.parentNode.style.visibility = "visible";
					dojo.addClass(scNode, "Opacity90");
					dojo.removeClass(scNode, "Opacity90");
				} else {
					console.warn('SidebarContent node not found in '+this.declaredClass);
				}
			}, 1);
			// minimize jitter of .PropertyContainer on recalc
		},

		_checkHeight: function(/* widget */ sidebar) {
		// check height of all sidebar content elements and set minheight
			var child = sidebar.containerNode.firstChild;
			var height = 0;
			while (child != null) {
				if(child.nodeType == 1 && child.offsetHeight){
					height += child.offsetHeight;
				}
				child = child.nextSibling;
			}
			//if(height != 0) this._setMinHeight(height);
			//this causes height problems with the left sidebar when the windows gets to slim (EPG-9594) - do we really need this?
		},

		_setMinHeight: function(/* integer */ height) {
			if($("EmbeddedStorefront")) {
				this.domNode.style.minHeight = "0";
			}else {
				if(this._contentScrollBarHandler === undefined) {
					this.domNode.style.minHeight=height+"px";
				}
			}
		}

	});
