dojo.provide('epages.cartridges.de_epages.presentation.widget.TextInlineEditor');
dojo.require('epages.cartridges.de_epages.presentation.widget.InlineEditor');
dojo.require("epages.html");

// inline editor for simple (unformatted) text
dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.TextInlineEditor",
	epages.cartridges.de_epages.presentation.widget.InlineEditor,
	{
		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			this.valueFormatted = this.value.replace(/\<br\s*\/?\>(?:\r?\n)?/gi, "\n");		// formatting for textarea
		},

		create: function() {
			this.inherited('create', arguments);
		},

		show: function() {
			// simple text input
			if (!this.isInited) {
				this._copyStyle(this.contentNode, this._computedStyle);
				this._resizeToContent();
				this.contentNode.style.display = '';
				this.contentNode.style.overflow = 'hidden';
				if (this.undoObject){
					this.undoObject.registerInput(this.contentNode);
				}
				// connect events
				this.connect(this.contentNode, 'click', '_resizeToContent');
				this.connect(this.contentNode, 'onkeyup', '_resizeToContent');
				this.connect(this.contentNode, 'onpaste', '_resizeToContent');
				this.connect(this.contentNode, 'onkeyup', 'onChangeContentNode');
				this.connect(this.contentNode, 'onpaste', 'onChangeContentNode');
				this.isInited = true;
			} else {
				this.contentNode.style.display = '';
			}
			this._resizeToContent();
			this.displayNode.style.display = 'none';
			this.contentNode.focus();
			this.inherited('show', arguments);
		},

		hide: function(evt) {
			if (!this.isInited){
				return;
			}
			if (this.contentNode.value == '') {
				this.displayNode.innerHTML = this._placeHolderText;
			} else {
				this.displayNode.innerHTML = epages.html.encodeEntity(this.contentNode.value, true);
			}
			this.displayNode.style.display = '';
			this.contentNode.style.display = 'none';
			this.inherited('hide', arguments);
		},

		// gets called, when data is changed (from outside)
		onChangeContentNode: function() {
			this.displayNode.innerHTML = epages.html.encodeEntity(this.contentNode.value);
			this.inherited("onChangeContentNode", arguments);
		}
	}
);
