/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Toolfont $Revision: 1.6.8.2 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Toolvisualaid");
dojo.require("epages.widget");
dojo.require("epages.html");
dojo.require("epages.cartridges.de_epages.presentation.visualaidcontroller");

dojo.declare("epages.cartridges.de_epages.presentation.widget.Toolvisualaid",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * private properties
		 */
		_classes      : ['ico_s_visualaid','ico_s_visualaid_hidden'],
		/**
		 * widget properties
		 */
		templatePath : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', "templates/Toolvisualaid.html"),
		imagePath    : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			this.connect(this.domNode, "onclick", '_setVisualAid');
			dojo.subscribe('presentation/setVisualAid', this, '_updateButton');  // multiple instances of this widget can react on a change
		},

		_setVisualAid: function() {
			epages.cartridges.de_epages.presentation.visualaidcontroller.toggleVisualAid();
		},

		_updateButton: function(opt) {
			epages.html.replaceClass(this.iconNode, this._classes[opt.isVisible ? 0 : 1], this._classes[opt.isVisible ? 1 : 0]);
		}
});
