dojo.provide("epages.cartridges.de_epages.shopwizard.widget.Contenttreenode");

dojo.require("epages.widget.LocalizedWidget");
dojo.require("dijit.Tree");
dojo.require('epages.string');
dojo.require('epages.widget.FormElement');

dojo.declare(
	"epages.cartridges.de_epages.shopwizard.widget.Contenttreenode",
	[epages.widget.LocalizedWidget,dijit._TreeNode],
	{
		/* public	*/
		iconSrc: epages.vars.StoreRoot + "/BO/icons/",
		iconAlt: '',
		objectClass: 'ContentObject',
		status:	'',
		statusCodes: {
			ENABLED: 'ENABLED',
			DISABLED:	'DISABLED',
			PREVIEW: 'PREVIEW'
		},
		isMandatory: 'false',
		isExisting:	'false',
		featureName: '',
		checked: 'false',
		hidden:	'false',
		checkBox:	undefined,

		/**
		 * widget	properties
		 */
		imagePath					:	 epages.themeUrl('images'),
		translationName		:	 dojo.moduleUrl('epages.cartridges.de_epages.shopwizard.widget','templates/translation'),

		buildRendering:	function(args, fragment, parent) {
			this.inherited("buildRendering", arguments);
			if(!this.item.top){
				this.translation.loadLocale(this.getTranslationName());
				if(this.item.isMandatory){
						this.isMandatory = this.item.isMandatory[0];
				}
				if(this.item.isExisting){
						this.isExisting	=	this.item.isExisting[0];
				}
				if(this.item.checked){	
						this.checked = this.item.checked[0];
				}
				this.checked = epages.string.toBoolean(this.checked);
				if(this.item.status){ 
						this.status = this.item.status[0];
				}
				if(this.item.hidden){ 
						this.hidden = this.item.hidden[0];
				}
				// add icon
				this.objectClass = this.item.objectClass[0];
				var	icon = document.createElement("i");
				icon.className = "Sprite " + "object_ico_s_"	+	this.objectClass.toLowerCase();
				icon.setAttribute("title", this.item.className[0]);
				this.contentNode.insertBefore(icon,	this.contentNode.firstChild);
				this.contentNode.parentNode.style.position = "relative";

				// add checkbox
				var	checkBox = document.createElement('input');
				checkBox.type	=	"text";
				checkBox.name	=	"Content";
				checkBox.startupValue = this.tree.model.getIdentity(this.item).replace(/democontent_/g, "");
				checkBox.value = checkBox.startupValue;
				checkBox.style.cssText = "margin-right:4px !important";
				checkBox.setAttribute("autocomplete",	false);
				dojo.addClass(checkBox, "Checkbox");

				if (this.status	== this.statusCodes.DISABLED) {
					checkBox.disabled	=	true;
					dojo.addClass(this.checkBox, "Disabled");
				}
				this.contentNode.insertBefore(checkBox,	this.contentNode.firstChild);

				checkBox.checked = this.checked;
				this.checkBox	=	checkBox;

				// set status
				if (!this.status.match(this.statusCodes.PREVIEW) &&	this.isExisting) {
					this.checkBox.value	=	"";
					this.checkBox.checked	=	true;
					this.checkBox.disabled = true;
					dojo.addClass(this.checkBox, "Disabled");
					this.checkBox.setAttribute("title",	this.translate('PageAlreadyExists'));

					// insert	"already exists" icons
					var	icon = document.createElement("img");
					icon.src = this.iconSrc	+	'object_ico_s_available.png';
					icon.height	=	16;
					icon.width = 16;
					icon.setAttribute("title", this.translate('PageAlreadyExists'));
					icon.setAttribute("alt", this.translate('PageAlreadyExists'));
					this.contentNode.appendChild(icon);
				}
				if (!this.status.match(this.statusCodes.PREVIEW) &&	this.isMandatory)	{
					this.checkBox.checked	=	true;
					this.checkBox.disabled = true;
					dojo.addClass(this.checkBox, "Disabled");
					this.checkBox.setAttribute("title",	this.translate('MandatoryElement'));
					dojo.addOnLoad(dojo.hitch(this,	"onCheckBoxClick"));

					// insert	mandatory	icon
					var	icon = document.createElement("img");
					icon.src = this.iconSrc	+	'ico_s_mandatory.png';
					icon.height	=	16;
					icon.width = 16;
					icon.setAttribute("title", this.translate('MandatoryElement'));
					icon.setAttribute("alt", this.translate('MandatoryElement'));
					this.contentNode.appendChild(icon);
				}

				if(this.status.match(this.statusCodes.PREVIEW))	{
					this.checkBox.style.display	=	"none";
					this.checkBox.disabled = true;
					dojo.addClass(this.checkBox, "Disabled");
				}
				if (epages.string.toBoolean(this.hidden)){	
					this.domNode.style.display = "none";
				}
				if (epages.string.toBoolean(this.checked)){ 
					dojo.addOnLoad(dojo.hitch(this, "onCheckBoxClick"));
				}
			}
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			setTimeout(dojo.hitch(this, function() {
				if(this.checkBox) {
					var checkedValue = this.checkBox.checked;
					var checkBoxWidget = new epages.widget.FormElement({}, this.checkBox);
					checkBoxWidget.setChecked(checkedValue);
					this.connect(checkBoxWidget.domNode, "onmousedown", function(evt) {
						// workaround: widgets inside of treenodes are not really supported by dojo
						// --> _onTreeFocus tries to find the enclosing widget and expects it to be a treeNode (onmosedown)
						dojo.stopEvent(evt);
						epages.event.fire(evt.currentTarget.parentNode, "mousedown");
					});
					this.connect(checkBoxWidget.domNode, "onactivate", function(evt) {
						dojo.stopEvent(evt);
					});
					this.checkBox = checkBoxWidget.elementNode;
					this.connect(this.checkBox, "onclick", "onCheckBoxClick");
					//this.onCheckBoxClick();
				}
			}), 1);
		},

		onCheckBoxClick: function(evt) {
			if(evt){
				dojo.stopEvent(evt);
			}
			if (this.checkBox.checked) {
				// check parent	too, if	needed
				if (this.getParent().checkBox	!= null	&& !this.getParent().checkBox.checked) {
					this.getParent().clickCheckBox();
				}
			}	else {
				// uncheck children	too, if	needed
				for( var i=0,iLength=this.getChildren().length ; i<iLength ; i++ )	{
					var	child	=	this.getChildren()[i];
					if (child.checkBox.checked)	{
						child.clickCheckBox();
					}
				}
			}
			dojo.publish(this.tree.id	+	"/clickCheckbox",	[{ node: this	}]);
		},

		clickCheckBox: function()	{
			if(!this.checkBox.disabled)	{
				this.checkBox.checked	=	!this.checkBox.checked;
				this.checked	=	!this.checked;
				this.onCheckBoxClick();
			}
		},

		updateLayout:	function() {
			if(this.domNode.style.display	!= 'none'){
				//update layout	of this	node and previous	node if	exists
				var	nextChild	=	this.getNextSibling();
				if(this.getPreviousSibling()){
					this.getPreviousSibling()._updateLayout();
				}
				if(nextChild ==	null ||	nextChild.domNode.style.display	== 'none'){
					dojo.addClass(this.domNode,	"dijitTreeIsLast");
				}
				else{
					//if node	is not the last	visible	use	_updateLayout	method
					this._updateLayout();
				}
				//check	for	children and set expand	icon
				if(this.isExpandable){
						this.tree._expandNode(this);
				}
				if(this.getChildren().length !=	0){
					var	childrenVisible	=	false;
					for(var	i=0,l=this.getChildren().length; i < l;	i++){
						if(this.getChildren()[i].domNode.style.display !=	'none'){
							childrenVisible	=	true;
						}
					}
					if(childrenVisible ==	true){
						this.isExpandable	=	true;
						this.isExpanded	=	true;
						this._setExpando(false);
					}
					else{
						this.isExpandable	=	false;
						this.isExpanded	=	false;
						this._setExpando(false);
					}
				}
				//update Layout	of parent	Node
				var	parentNode = this.getParent();
				if(parentNode.isExpandable ==	false){
					parentNode.isExpandable	=	true;
					parentNode.isExpanded	=	true;
					parentNode._setExpando(false);
				}
			}
			//if node	is set to	'display none' change	layout of	previous node
			if(this.domNode.style.display	== 'none'){
				if(this.getPreviousSibling()){	
					dojo.addClass(this.getPreviousSibling().domNode, "dijitTreeIsLast");
				}
				//update Layout	of parent	Node
				var	parentNode = this.getParent();
				var	childrenNodes	=	parentNode.getChildren();
				var	visible	=	false;
				for(var	i	=	0; i < childrenNodes.length; i++){
					if(childrenNodes[i].domNode.style.display	!= undefined &&	childrenNodes[i].domNode.style.display !=	'none'){
						visible	=	true;
					}
				}
				if(visible ==	false){
					parentNode.isExpandable	=	false;
					parentNode.isExpanded	=	false;
					parentNode._setExpando(false);
				}
			}
		},

		checkAll:	function() {
			if (this.item.status[0]	== this.statusCodes.ENABLED	&& !this.checkBox.checked){ 
				this.clickCheckBox();
			}
			for( var i=0,iLength=this.getChildren().length ; i<iLength ; i++ )	{
				this.getChildren()[i].checkAll();
			}
		},

		uncheckAll:	function() {
			if (this.item.status[0]	== this.statusCodes.ENABLED	&& this.checkBox.checked){	
				this.clickCheckBox();
			}
			for( var i=0,iLength=this.getChildren().length ; i<iLength ; i++ )	{
				this.getChildren()[i].uncheckAll();
			}
		}
	}
);
