/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.democontentTree $Revision: 1.8.4.4 $

*/
dojo.provide("epages.cartridges.de_epages.shopwizard.widget.democontentTree");
dojo.require("dijit.Tree");
dojo.require('epages.cartridges.de_epages.shopwizard.widget.Contenttreenode');
dojo.require('epages.browser');

dojo.declare(
	"epages.cartridges.de_epages.shopwizard.widget.democontentTree",
	[dijit.Tree],
	{
		/**
		* public properties
		*/
		label             : 'democontentTree',
		persist            : false,
		/**
		* private properties
		*/
		_lastSelectedNode : undefined,
		/**
		* public methods
		*/

	_createTreeNode: function(/*Object*/ args){
		args.id = this.model.getIdentity(args.item);
		return new epages.cartridges.de_epages.shopwizard.widget.Contenttreenode(args);
	},

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			this.expandNodeAndChildren(this.rootNode);
			this.collapseNodeAndChildren(this.rootNode);

			if(epages.Browser.engine == "MSIE") {
				dojo.addOnLoad(dojo.hitch(this, function() {
					// MSE IE Workaround -> force rendering to solve problems with filter changes (which cause silly display problems)
					dojo.addClass(this.domNode, "Opacity90");
					setTimeout(dojo.hitch(this, function() {
						dojo.removeClass(this.domNode, "Opacity90");
					}),1);
				}));
			}
		},

		expandNodeAndChildren: function(node){
			var childrenNodes = node.getChildren();
			for( var i=0,iLength=childrenNodes.length ; i<iLength ; i++ ){
				this._expandNode(childrenNodes[i]);
				if(childrenNodes[i].getChildren().length != 0){
					this.expandNodeAndChildren(childrenNodes[i]);
				}
			}
		},

		collapseNodeAndChildren: function(node){
			var childrenNodes = node.getChildren();
			for( var i=0,iLength=childrenNodes.length ; i<iLength ; i++ ){
				this._collapseNode(childrenNodes[i]);
				if(childrenNodes[i].getChildren().length != 0){
					this.collapseNodeAndChildren(childrenNodes[i]);
				}
			}
		},

		checkAll: function(){
			var childNodes = this.rootNode.getChildren();
			for( var i=0,l=childNodes.length ; i<l ; i++ ){
				//expand node first to check all children too, because childrens do not exist before expand
				this._expandNode(childNodes[i]);
				childNodes[i].checkAll();
			}
		},

		uncheckAll: function(){
			var childNodes = this.rootNode.getChildren();
			for( var i=0,l=childNodes.length ; i<l ; i++ ){
				childNodes[i].uncheckAll();
			}
		},

		onClick: function(item,node){
			if(!item.top){
				node.clickCheckBox();
			}
		}

});
