#!/bin/bash
#-----BEGIN PGP SIGNATURE-----
#Version: GnuPG v1.2.6 (GNU/Linux)
#Comment: 2008-11-24 ePages Software GmbH (release key) <rnd@epages.de>
#
#iD8DBQBMymjhl5jMabHSgyARAurlAKCI1DfwsaNG9LtC5fSF4NejeChjEwCfRtGa
#mAQXzP5meKX/TEUCAcuEQlc=
#=c/kd
#-----END PGP SIGNATURE-----
#line 2

if [[ ! -w /etc/passwd ]] ; then
  echo "Error: Only 'root' can execute this program!"
  exit 1
fi

URL=http://epages.com/RPMS/rpmify/rpm-fixes
unset FIXED

for i in epages epages-setup epages-sybase ; do
  while read VERSION ; do
    rpm -q --qf "%{POSTUN}" $i-$VERSION 2>/dev/null | grep -q 'rm -rf' || continue
    case $VERSION in
      6.10.2) FIXED=1 ; FIXIT=1 ;;
      6) FIXED=1 ; FIXIT=1 ;;
      *) unset FIXIT ;;
    esac
    [[ -n $FIXIT ]] && { rpm -hiv --force $URL/$i-$VERSION-0.i386.rpm || exit 1; }
  done < <(rpm -q --qf "%{VERSION}\n" $i 2>/dev/null)
done

[[ -n $FIXED ]] && echo "(rpms fixed)" || echo "(nothing to do)" 
exit 0
